-- block the default filltype loading to load only TLP filltypes

FillTypeManagerExtension = {}
function FillTypeManagerExtension:loadDefaultTypes(superFunc)
	self:addFillType("UNKNOWN", "Unknown", false, 0, 0, 0, "", nil, nil, nil, nil, nil, {}, "$data/fillPlanes/wheat_diffuse.png", "$data/fillPlanes/wheat_normal.png", "$data/fillPlanes/wheat_specular.png", nil, nil, nil, nil, nil, true)
end
FillTypeManager.loadDefaultTypes = Utils.overwrittenFunction(FillTypeManager.loadDefaultTypes, FillTypeManagerExtension.loadDefaultTypes)


function FillTypeManagerExtension:loadMapData(superFunc, xmlFile, missionInfo, baseDirectory)
	FillTypeManager:superClass().loadMapData(self)
	self:loadDefaultTypes()
	if XMLUtil.loadDataFromMapXML(xmlFile, "fillTypes", baseDirectory, self, self.loadFillTypes, baseDirectory, false, missionInfo.customEnvironment) then
		XMLUtil.loadDataFromMapXML(xmlFile, "fillTypesMap", baseDirectory, self, self.loadFillTypes, baseDirectory, false, missionInfo.customEnvironment)
		for _, data in ipairs(self.modsToLoad) do
			local fillTypesXmlFile = XMLFile.load("fillTypes", data[1], FillTypeManager.xmlSchema)

			g_fillTypeManager:loadFillTypes(fillTypesXmlFile, data[2], false, data[3])
			fillTypesXmlFile:delete()
		end

		self:constructFillTypeTextureArrays()

		return true
	end

	return false
end
FillTypeManager.loadMapData = Utils.overwrittenFunction(FillTypeManager.loadMapData, FillTypeManagerExtension.loadMapData)


local function DensityMapHeightManagerDoNothing(self, superFunc, missionInfo, baseDirectory)
	self:initDataStructures()
end
DensityMapHeightManager.loadDefaultTypes = Utils.overwrittenFunction(DensityMapHeightManager.loadDefaultTypes, DensityMapHeightManagerDoNothing)




local function FruitTypeManagerDoNothing(self, superFunc)
end
FruitTypeManager.loadDefaultTypes = Utils.overwrittenFunction(FruitTypeManager.loadDefaultTypes, FruitTypeManagerDoNothing)


WeedSystemExtension = {}
function WeedSystemExtension:loadMapData(superFunc, xmlFile, missionInfo, baseDirectory)
	self.baseDirectory = baseDirectory
	-- self:loadWeed("data/maps/maps_weed.xml")

	local filename = getXMLString(xmlFile, "map.weed#filename")

	if filename ~= nil then
		filename = Utils.getFilename(filename, baseDirectory)

		self:loadWeed(filename)
	end

	if g_currentMission:getIsServer() and g_addCheatCommands then
		addConsoleCommand("gsWeedSystemAddDelta", "Add weed delta to field", "consoleCommandAddDelta", self)
		addConsoleCommand("gsWeedSystemSetState", "Set weed state to field", "consoleCommandSetState", self)
	end

	return true
end

WeedSystem.loadMapData = Utils.overwrittenFunction(WeedSystem.loadMapData, WeedSystemExtension.loadMapData)


FruitTypeMangerExtension = {}
function FruitTypeMangerExtension.loadFruitTypes(self, superFunc, xmlFile, var1, var2)
	if var2 ~= nil then
		--Premium DLC Früchte nicht laden
		return
	end
	local returnValue = superFunc(self, xmlFile, var1, var2)

	return returnValue
end

FruitTypeManager.loadFruitTypes = Utils.overwrittenFunction(FruitTypeManager.loadFruitTypes, FruitTypeMangerExtension.loadFruitTypes)