Environment.PERIODS_IN_YEAR = 48
Environment.MAX_DAYS_PER_PERIOD = 7


Environment.PERIOD = {
	EARLY_SPRING = 1,
	EARLY_SPRING_SECOND = 2,
	EARLY_SPRING_THIRD = 3,
	EARLY_SPRING_FOURTH = 4,
	MID_SPRING = 5,
	MID_SPRING_SECOND = 6,
	MID_SPRING_THIRD = 7,
	MID_SPRING_FOURTH = 8,
	LATE_SPRING = 9,
	LATE_SPRING_SECOND = 10,
	LATE_SPRING_THIRD = 11,
	LATE_SPRING_FOURTH = 12,
	EARLY_SUMMER = 13,
	EARLY_SUMMER_SECOND = 14,
	EARLY_SUMMER_THIRD = 15,
	EARLY_SUMMER_FOURTH = 16,
	MID_SUMMER = 17,
	MID_SUMMER_SECOND = 18,
	MID_SUMMER_THIRD = 19,
	MID_SUMMER_FOURTH = 20,
	LATE_SUMMER = 21,
	LATE_SUMMER_SECOND = 22,
	LATE_SUMMER_THIRD = 23,
	LATE_SUMMER_FOURTH = 24,
	EARLY_AUTUMN = 25,
	EARLY_AUTUMN_SECOND = 26,
	EARLY_AUTUMN_THIRD = 27,
	EARLY_AUTUMN_FOURTH = 28,
	MID_AUTUMN = 29,
	MID_AUTUMN_SECOND = 30,
	MID_AUTUMN_THIRD = 31,
	MID_AUTUMN_FOURTH = 32,
	LATE_AUTUMN = 33,
	LATE_AUTUMN_SECOND = 34,
	LATE_AUTUMN_THIRD = 35,
	LATE_AUTUMN_FOURTH = 36,
	EARLY_WINTER = 37,
	EARLY_WINTER_SECOND = 38,
	EARLY_WINTER_THIRD = 39,
	EARLY_WINTER_FOURTH = 40,
	MID_WINTER = 41,
	MID_WINTER_SECOND = 42,
	MID_WINTER_THIRD = 43,
	MID_WINTER_FOURTH = 44,
	LATE_WINTER_FIRST = 45,
	LATE_WINTER_SECOND = 46,
	LATE_WINTER_THIRD = 47,
	LATE_WINTER = 48
}
Environment.PERIOD_DAY_MAPPING = {
	[Environment.PERIOD.EARLY_SPRING] = 67,
	[Environment.PERIOD.EARLY_SPRING_SECOND] = 75,
	[Environment.PERIOD.EARLY_SPRING_THIRD] = 82,
	[Environment.PERIOD.EARLY_SPRING_FOURTH] = 90,
	[Environment.PERIOD.MID_SPRING] = 97,
	[Environment.PERIOD.MID_SPRING_SECOND] = 105,
	[Environment.PERIOD.MID_SPRING_THIRD] = 112,
	[Environment.PERIOD.MID_SPRING_FOURTH] = 120,
	[Environment.PERIOD.LATE_SPRING] = 127,
	[Environment.PERIOD.LATE_SPRING_SECOND] = 135,
	[Environment.PERIOD.LATE_SPRING_THIRD] = 142,
	[Environment.PERIOD.LATE_SPRING_FOURTH] = 150,
	[Environment.PERIOD.EARLY_SUMMER] = 157,
	[Environment.PERIOD.EARLY_SUMMER_SECOND] = 165,
	[Environment.PERIOD.EARLY_SUMMER_THIRD] = 172,
	[Environment.PERIOD.EARLY_SUMMER_FOURTH] = 180,
	[Environment.PERIOD.MID_SUMMER] = 187,
	[Environment.PERIOD.MID_SUMMER_SECOND] = 195,
	[Environment.PERIOD.MID_SUMMER_THIRD] = 202,
	[Environment.PERIOD.MID_SUMMER_FOURTH] = 210,
	[Environment.PERIOD.LATE_SUMMER] = 217,
	[Environment.PERIOD.LATE_SUMMER_SECOND] = 225,
	[Environment.PERIOD.LATE_SUMMER_THIRD] = 232,
	[Environment.PERIOD.LATE_SUMMER_FOURTH] = 240,
	[Environment.PERIOD.EARLY_AUTUMN] = 247,
	[Environment.PERIOD.EARLY_AUTUMN_SECOND] = 255,
	[Environment.PERIOD.EARLY_AUTUMN_THIRD] = 262,
	[Environment.PERIOD.EARLY_AUTUMN_FOURTH] = 270,
	[Environment.PERIOD.MID_AUTUMN] = 277,
	[Environment.PERIOD.MID_AUTUMN_SECOND] = 285,
	[Environment.PERIOD.MID_AUTUMN_THIRD] = 292,
	[Environment.PERIOD.MID_AUTUMN_FOURTH] = 300,
	[Environment.PERIOD.LATE_AUTUMN] = 307,
	[Environment.PERIOD.LATE_AUTUMN_SECOND] = 315,
	[Environment.PERIOD.LATE_AUTUMN_THIRD] = 322,
	[Environment.PERIOD.LATE_AUTUMN_FOURTH] = 330,
	[Environment.PERIOD.EARLY_WINTER] = 337,
	[Environment.PERIOD.EARLY_WINTER_SECOND] = 345,
	[Environment.PERIOD.EARLY_WINTER_THIRD] = 352,
	[Environment.PERIOD.EARLY_WINTER_FOURTH] = 360,
	[Environment.PERIOD.MID_WINTER] = 7,
	[Environment.PERIOD.MID_WINTER_SECOND] = 15,
	[Environment.PERIOD.MID_WINTER_THIRD] = 22,
	[Environment.PERIOD.MID_WINTER_FOURTH] = 30,
	[Environment.PERIOD.LATE_WINTER_FIRST] = 37,
	[Environment.PERIOD.LATE_WINTER_SECOND] = 45,
	[Environment.PERIOD.LATE_WINTER_THIRD] = 52,
	[Environment.PERIOD.LATE_WINTER] = 60
}

TLEnvironmentExtension = {}
function TLEnvironmentExtension:getDaysPerSeason(superFunc)
	return self.daysPerPeriod * 12
end

function TLEnvironmentExtension:updateTimeValues(superFunc, initialState)
	local timeHoursF = self.dayTime / 3600000 + 0.0001
	local timeHours = math.floor(timeHoursF)
	local timeMinutes = math.floor((timeHoursF - timeHours) * 60)

	self.environmentMaskSystem:setDayTime(self.dayTime)

	local hourChanged = false
	local dayChanged = false
	local periodChanged = false
	local seasonChanged = false
	local yearChanged = false
	local periodLengthChanged = false

	if timeMinutes ~= self.currentMinute then
		while timeMinutes ~= self.currentMinute do
			self.currentMinute = self.currentMinute + 1

			if self.currentMinute >= 60 then
				self.currentMinute = 0
			end

			self:updateAmbientSoundModifiers()

			if not initialState then
				g_messageCenter:publish(MessageType.MINUTE_CHANGED, self.currentMinute)
				self.mission:onMinuteChanged(self.currentMinute)
			end
		end
	end

	if timeHours ~= self.currentHour then
		self.currentHour = timeHours

		if self.currentHour == 24 then
			self.currentHour = 0
		end

		hourChanged = true
	end

	if self.dayTime > 86400000 then
		self.dayTime = self.dayTime - 86400000
		self.currentDay = self.currentDay + 1
		self.currentMonotonicDay = self.currentMonotonicDay + 1
		dayChanged = true
	end

	if dayChanged or initialState then
		self.currentDayInPeriod = (self.currentDay - 1) % self.daysPerPeriod + 1
		local period = math.ceil(((self.currentDay - 1) % (self.daysPerPeriod * Environment.PERIODS_IN_YEAR) + 1) / self.daysPerPeriod)

		if period ~= self.currentPeriod then
			self.currentPeriod = period

			if not self.visualPeriodLocked then
				self.currentVisualPeriod = self.currentPeriod
			end

			periodChanged = true
		end
		-- Achim: change 3 to 12
		local season = math.fmod(math.floor((self.currentDay - 1) / (self.daysPerPeriod * 12)), Environment.SEASONS_IN_YEAR)

		if season ~= self.currentSeason then
			self.currentSeason = season

			if not self.visualPeriodLocked then
				self.currentVisualSeason = season
			end

			seasonChanged = true

			if self.daysPerPeriod ~= self.plannedDaysPerPeriod then
				local oldDaysPerPeriod = self.daysPerPeriod
				self.daysPerPeriod = self.plannedDaysPerPeriod
				self.timeAdjustment = 1 / (self.daysPerPeriod * 4)
				self.currentDay = math.floor((self.currentDay - 1) / oldDaysPerPeriod * self.daysPerPeriod) + 1
				self.currentDayInPeriod = (self.currentDay - 1) % self.daysPerPeriod + 1
				periodLengthChanged = true
			end
		end
		-- Achim: change 3 to 12
		self.currentDayInSeason = math.fmod(self.currentDay - 1, self.daysPerPeriod * 12) + 1

		if self.visualPeriodLocked then
			self.currentVisualDayInSeason = math.floor((self.currentVisualPeriod - 1) % 1.5 * self.daysPerPeriod + 1)
		else
			self.currentVisualDayInSeason = self.currentDayInSeason
		end

		local year = math.floor((self.currentDay - 1) / (self.daysPerPeriod * Environment.PERIODS_IN_YEAR)) + 1

		if year ~= self.currentYear then
			self.currentYear = year
			yearChanged = true
		end
	end

	if dayChanged or initialState then
		self:updateJulianDay()
	end

	if hourChanged and not initialState then
		g_messageCenter:publish(MessageType.HOUR_CHANGED, self.currentHour)
		self.mission:onHourChanged()
	end

	if dayChanged and not initialState then
		g_messageCenter:publish(MessageType.DAY_CHANGED, self.currentDay)
		self.mission:onDayChanged()

		if periodLengthChanged then
			g_messageCenter:publish(MessageType.PERIOD_LENGTH_CHANGED, self.daysPerPeriod, self.timeAdjustment)
		end

		if periodChanged then
			g_messageCenter:publish(MessageType.WEEK_CHANGED, self.currentPeriod)

			local ambientSounds = self.ambientSoundModifiers
			local period = Environment.PERIOD
			local currentVisualPeriod = self.currentVisualPeriod
			local currentPeriod = self.currentPeriod
			-- TerraLiveExtension.DebugText("TLEnvironmentExtension:updateTimeValues - periodChanged: %s", currentPeriod)
			-- TerraLiveExtension.DebugTable("Environment.PERIOD", Environment.PERIOD)
			
			-- this only needs to be executed when the current period is first of the 4 weeks
			if 
				currentPeriod == period.EARLY_SPRING or 
				currentPeriod == period.MID_SPRING or 
				currentPeriod == period.LATE_SPRING or 
				currentPeriod == period.EARLY_SUMMER or 
				currentPeriod == period.MID_SUMMER or 
				currentPeriod == period.LATE_SUMMER or 
				currentPeriod == period.EARLY_AUTUMN or 
				currentPeriod == period.MID_AUTUMN or 
				currentPeriod == period.LATE_AUTUMN or 
				currentPeriod == period.EARLY_WINTER or 
				currentPeriod == period.MID_WINTER or 
				currentPeriod == period.LATE_WINTER then
				g_messageCenter:publish(MessageType.PERIOD_CHANGED, self.currentPeriod)
			end
			
			-- this only needs to be done when the visual period change to the first of the 4 weeks
			ambientSounds.setIsSpring(currentVisualPeriod == period.EARLY_SPRING or currentVisualPeriod == period.MID_SPRING or currentVisualPeriod == period.LATE_SPRING)
			ambientSounds.setIsSummer(currentVisualPeriod == period.EARLY_SUMMER or currentVisualPeriod == period.MID_SUMMER or currentVisualPeriod == period.LATE_SUMMER)
			ambientSounds.setIsAutumn(currentVisualPeriod == period.EARLY_AUTUMN or currentVisualPeriod == period.MID_AUTUMN or currentVisualPeriod == period.LATE_AUTUMN)
			ambientSounds.setIsWinter(currentVisualPeriod == period.EARLY_WINTER or currentVisualPeriod == period.MID_WINTER or currentVisualPeriod == period.LATE_WINTER)
			self.environmentMaskSystem:setDayOfYear(Environment.PERIOD_DAY_MAPPING[currentVisualPeriod], self.currentVisualSeason)
		end

		if seasonChanged then
			g_messageCenter:publish(MessageType.SEASON_CHANGED, self.currentSeason)
		end

		if yearChanged then
			g_messageCenter:publish(MessageType.YEAR_CHANGED, self.currentYear)
		end
	end
end

function TLEnvironmentExtension:getSeasonShaderValue(superFunc)
	if self.visualPeriodLocked then
		return (self.currentVisualSeason - 1) % 4 + 0.5
	end

	local pInDay = self.dayTime * Environment.DAYTIME_TO_HOURS_MULT + 0.0001
	local shaderSeason = (self.currentSeason - 1) % 4
	local day = self.currentDay
	local daysPerSeason = 12 * self.daysPerPeriod
	local pInSeason = (day - 1) % daysPerSeason / daysPerSeason
	local alpha = pInSeason + pInDay / daysPerSeason

	return shaderSeason + alpha
end

function TLEnvironmentExtension:getSeasonAtDay(superFunc,day)
	local diff = day - self.currentMonotonicDay
	local seasonalDay = self.currentDay + diff

	return math.fmod(math.floor((seasonalDay - 1) / (self.daysPerPeriod * 12)), Environment.SEASONS_IN_YEAR)
end

function TLEnvironmentExtension:getJulianDay(superFunc)
	local startDays = Environment.JULIAN_DAYS_NORTH

	if self.daylight.latitude < 0 then
		startDays = Environment.JULIAN_DAYS_SOUTH
	end

	local partInSeason = self.currentVisualDayInSeason / (12 * self.daysPerPeriod)

	return math.fmod(math.floor(startDays[self.currentVisualSeason] + partInSeason * 91), 365)
end

function TLEnvironmentExtension:setFixedPeriod(superFunc, period)
	if period == nil and self.visualPeriodLocked == true then
		self.visualPeriodLocked = false
		self.currentVisualPeriod = self.currentPeriod
		self.currentVisualSeason = self.currentSeason
		self.currentDayInSeason = math.fmod(self.currentDay - 1, self.daysPerPeriod * 12) + 1
		self.currentVisualDayInSeason = self.currentDayInSeason
		self.mission.missionInfo.fixedSeasonalVisuals = nil

		self:updateJulianDay()
		self.weather:rebuild()
	elseif period ~= nil and (self.visualPeriodLocked == false or self.currentVisualPeriod ~= period) then
		period = MathUtil.clamp(period, 1, 12)
		self.visualPeriodLocked = true
		self.currentVisualPeriod = period
		self.currentVisualSeason = math.floor((period - 1) / 3)
		self.currentDayInSeason = math.fmod(self.currentDay - 1, self.daysPerPeriod * 12) + 1
		self.currentVisualDayInSeason = math.floor((self.currentVisualPeriod - 1) % 1.5 * self.daysPerPeriod + 1)
		self.mission.missionInfo.fixedSeasonalVisuals = period

		self:updateJulianDay()
		self.weather:rebuild()
	end
end

MessageType.WEEK_CHANGED = nextMessageTypeId()

local Farm_mt = Class(Farm, Object)

function Farm.new(isServer, isClient, customMt, spectator)
	local self = Object.new(isServer, isClient, customMt or Farm_mt)
	self.farmId = nil
	self.name = ""
	self.color = 0
	self.isSpectator = spectator or false

	self:setInitialEconomy()

	self.players = {}
	self.uniqueUserIdToPlayer = {}
	self.userIdToPlayer = {}
	self.activeUsers = {}
	self.contractingFor = {}
	self.handTools = {}
	self.stats = FarmStats.new()

	g_messageCenter:subscribe(MessageType.FARM_PROPERTY_CHANGED, self.farmPropertyChanged, self)

	if self.isServer then
		g_messageCenter:subscribe(MessageType.WEEK_CHANGED, self.periodChanged, self)
	end

	self.farmMoneyDirtyFlag = self:getNextDirtyFlag()
	self.lastMoneySent = self.money

	return self
end

function TLEnvironmentExtension:loadEnvironment()
	self.timeAdjustment = 1 / (self.daysPerPeriod * 4)
end

function TLEnvironmentExtension:loadFromXMLFileEnvironment()
	self.timeAdjustment = 1 / (self.daysPerPeriod * 4)
end

--Angepasste Ladefunktion um growth aus TLP zu laden
function TLEnvironmentExtension:loadMapDataGrowthSystem(superFunc, mapXmlFile, missionInfo, baseDirectory)
	self.missionInfo = missionInfo
	self.environment = self.mission.environment
	local filename = Utils.getFilename(getXMLString(mapXmlFile, "map.growth#filename"), baseDirectory)
	local xmlFile = XMLFile.load("growth", filename)

	if not xmlFile then
		Logging.fatal("Could not load '%s' from '%s'", filename, mapXmlFile)
	end

	if xmlFile:hasProperty("growth.terraLifePlus") then
		print("TerraLife Plus: Loading TerraLifePlus Growth")
		xmlFile:iterate("growth.fruits.fruit", function (index, key)
			local name = xmlFile:getString(key .. "#name")
			local path = Utils.getFilename("$moddir$FS22_TerraLifePlus/growth/"..name..".xml", baseDirectory)
			if fileExists(path) then
				local growthXML = XMLFile.load("growth", path)
				if not growthXML then
					Logging.fatal("Could not load '%s' from '%s'", filename, mapXmlFile)
				end
				self:loadGrowthData(growthXML, "growth")
				growthXML:delete()
			end
		end)
	else
		self:loadGrowthData(xmlFile, "growth")
	end

	xmlFile:delete()

	if g_addTestCommands then
		addConsoleCommand("gsGrowNow", "Force growth on foliage", "consoleCommandGrowNow", self)
	end

	g_messageCenter:subscribe(MessageType.WEEK_CHANGED, self.onPeriodChanged, self)
end

Environment.getDaysPerSeason = Utils.overwrittenFunction(Environment.getDaysPerSeason, TLEnvironmentExtension.getDaysPerSeason)
Environment.updateTimeValues = Utils.overwrittenFunction(Environment.updateTimeValues, TLEnvironmentExtension.updateTimeValues)
Environment.getSeasonShaderValue = Utils.overwrittenFunction(Environment.getSeasonShaderValue, TLEnvironmentExtension.getSeasonShaderValue)
Environment.getSeasonAtDay = Utils.overwrittenFunction(Environment.getSeasonAtDay, TLEnvironmentExtension.getSeasonAtDay)
Environment.getJulianDay = Utils.overwrittenFunction(Environment.getJulianDay, TLEnvironmentExtension.getJulianDay)
Environment.setFixedPeriod = Utils.overwrittenFunction(Environment.setFixedPeriod, TLEnvironmentExtension.setFixedPeriod)
GrowthSystem.loadMapData = Utils.overwrittenFunction(GrowthSystem.loadMapData, TLEnvironmentExtension.loadMapDataGrowthSystem)
Environment.load = Utils.appendedFunction(Environment.load, TLEnvironmentExtension.loadEnvironment)
Environment.loadFromXMLFile = Utils.appendedFunction(Environment.loadFromXMLFile, TLEnvironmentExtension.loadFromXMLFileEnvironment)

TLGrowthSystemExtension = {}
function TLGrowthSystemExtension:loadGrowthData(superFunc, xmlFile, root)
	if root == "foliageType.growth" then
		--Premium DLC nicht laden
		return
	end
	-- print(string.format("TLGrowthSystemExtension:loadGrowthData(%s, %s, %s)", superFunc, xmlFile, root));
	if self.seasonalFruitData == nil or self.nonSeasonalFruitData == nil then
		self.seasonalFruitData = {}
		self.nonSeasonalFruitData = {}
	end

	xmlFile:iterate(root .. ".seasonal.fruit", function (_, fruitKey)
		local fruitName = xmlFile:getString(fruitKey .. "#name")

		if fruitName == nil then
			Logging.error("Fruit name is missing at %s", fruitKey)

			return
		end

		local fruitDesc = g_fruitTypeManager:getFruitTypeByName(fruitName)

		if fruitDesc == nil then
			Logging.error("Fruit with name '%s' does not exist at %s", fruitName, fruitKey)

			return
		end

		local initialState = self:parseRange(fruitDesc, xmlFile:getString(fruitKey .. "#initialState"))
		self.seasonalFruitData[fruitDesc.index] = {
			initialState = initialState
		}
		local fruitData = self.seasonalFruitData[fruitDesc.index]

		xmlFile:iterate(fruitKey .. ".period", function (_, periodKey)
			local period = xmlFile:getInt(periodKey .. "#index")

			if period == nil or period < 1 or period > 48 then
				Logging.xmlError(xmlFile, "Invalid period for '%s'", periodKey)

				return
			end

			local info = {
				plantingAllowed = xmlFile:getBool(periodKey .. "#plantingAllowed", false),
				growthMapping = {}
			}
			fruitData[period] = info

			-- fix für max state
			local maxState = math.max(fruitDesc.destruction.state, fruitDesc.witheredState)
			for state = 1, maxState do
				info.growthMapping[state] = state
			end

			info.growthMapping[fruitDesc.cutState] = fruitDesc.cutState

			xmlFile:iterate(periodKey .. ".update", function (_, updateKey)
				local range = self:parseRange(fruitDesc, xmlFile:getString(updateKey .. "#range"))

				if range == nil then
					Logging.xmlError(xmlFile, "Update action of fruit growth definition is missing range", updateKey)

					return
				end

				local add = xmlFile:getInt(updateKey .. "#add")

				if add ~= nil then
					for state = range[1], range[2] do
						info.growthMapping[state] = state + add
					end
				else
					local set = self:parseStateValue(fruitDesc, xmlFile:getString(updateKey .. "#set"))

					if set ~= nil then
						for state = range[1], range[2] do
							info.growthMapping[state] = set
						end
					end
				end
			end)
		end)

		for period = 1, 48 do
		--Premium Test
			if fruitData[period] ~=nil then
				if fruitData[period].plantingAllowed then
					local state = 1

					for offset = 0, 96 do
						local currentPeriod = (period + offset - 1) % 48 + 1
						--Premium Test

						if fruitDesc.minHarvestingGrowthState == nil or fruitDesc.maxHarvestingGrowthState == nil then
							--print("GrowthState empty")
						elseif state == nil then
						--print("State ist nil")
						else
							if fruitDesc.minHarvestingGrowthState <= state and state <= fruitDesc.maxHarvestingGrowthState then
								fruitData[currentPeriod].harvestPossible = true
							elseif fruitDesc.minPreparingGrowthState <= state and state <= fruitDesc.maxPreparingGrowthState then
								fruitData[currentPeriod].harvestPossible = true
							elseif state == fruitDesc.witheredState then
								break
							end

							local mapping = fruitData[currentPeriod].growthMapping
							state = mapping[state]
						end
					end
				end
			end
		end
		-- TerraLiveExtension.DebugTable(fruitDesc.name, fruitData)
	end)
	xmlFile:iterate(root .. ".nonSeasonal.fruit", function (_, fruitKey)
		local fruitName = xmlFile:getString(fruitKey .. "#name")

		if fruitName == nil then
			Logging.xmlError(xmlFile, "Fruit name is missing at %s", fruitKey)

			return
		end

		local fruitDesc = g_fruitTypeManager:getFruitTypeByName(fruitName)

		if fruitDesc == nil then
			Logging.xmlError(xmlFile, "Fruit with name '%s' does not exist at %s", fruitName, fruitKey)

			return
		end

		local fruitData = {
			growthMapping = {}
		}

		for state = 1, fruitDesc.witheredState do
			fruitData.growthMapping[state] = state
		end

		xmlFile:iterate(fruitKey .. ".update", function (_, updateKey)
			local range = self:parseRange(fruitDesc, xmlFile:getString(updateKey .. "#range"))

			if range == nil then
				Logging.xmlError(xmlFile, "Update action of fruit growth definition is missing range", updateKey)

				return
			end

			local add = xmlFile:getInt(updateKey .. "#add")

			if add ~= nil then
				for state = range[1], range[2] do
					fruitData.growthMapping[state] = state + add
				end
			else
				local set = self:parseStateValue(fruitDesc, xmlFile:getString(updateKey .. "#set"))

				if set ~= nil then
					for state = range[1], range[2] do
						fruitData.growthMapping[state] = set
					end
				end
			end
		end)

		self.nonSeasonalFruitData[fruitDesc.index] = fruitData
	end)
	-- TerraLiveExtension.DebugTable("self.seasonalFruitData", self.seasonalFruitData)
end

function TLGrowthSystemExtension:onPeriodChanged(superFunc)
	-- print(string.format("TLGrowthSystemExtension:onPeriodChanged(%s)", superFunc));
	local transitionPeriod = self.environment.currentPeriod - 1

	if transitionPeriod == 0 then
		transitionPeriod = 48
	end
	
	self:triggerGrowth(transitionPeriod)
end


GrowthSystem.onPeriodChanged = Utils.overwrittenFunction(GrowthSystem.onPeriodChanged, TLGrowthSystemExtension.onPeriodChanged)
GrowthSystem.loadGrowthData = Utils.overwrittenFunction(GrowthSystem.loadGrowthData, TLGrowthSystemExtension.loadGrowthData)


TLI18NExtension = {}
function TLI18NExtension:formatPeriod(superFunc, period, useShort)
	-- print(string.format("TLI18NExtension:formatPeriod(%s,%s,%s)", superFunc, period, useShort));
	local isSouthern = false

	if g_currentMission ~= nil and g_currentMission.environment ~= nil then
		isSouthern = g_currentMission.environment.daylight.latitude < 0

		if period == nil then
			period = g_currentMission.environment.currentPeriod
		end
	end

	if period == nil then
		return nil
	end
	
	-- zusatz info
	local week = period%4;
	if week == 0 then
		week = 4
	end
	local part = string.format(g_i18n:getText("TL_week_short"), week) 
	
	-- umrechnen von 48 auf 12
	period = math.ceil(period / 4);

	local month = period + 2

	if isSouthern then
		month = month + 6
	end

	month = (month - 1) % 12 + 1
	
	return part .. self:getText("ui_month" .. month .. (useShort and "_short" or ""))
end

I18N.formatPeriod = Utils.overwrittenFunction(I18N.formatPeriod, TLI18NExtension.formatPeriod)

function I18N:formatPeriodAsMonth(period, useShort)
	local isSouthern = false

	if g_currentMission ~= nil and g_currentMission.environment ~= nil then
		isSouthern = g_currentMission.environment.daylight.latitude < 0

		if period == nil then
			period = g_currentMission.environment.currentPeriod
		end
	end

	if period == nil then
		return nil
	end

	local month = period + 2

	if isSouthern then
		month = month + 6
	end

	month = (month - 1) % 12 + 1

	return self:getText("ui_month" .. month .. (useShort and "_short" or ""))
end

-- Der Dialog muss komplett überarbeitet werden
TLInGameMenuCalendarFrameExtension = {}
function TLInGameMenuCalendarFrameExtension:setPeriodTitles()
	for i = 1, 12 do
		local element = self.calendarHeader[i]

		element:setText(g_i18n:formatPeriodAsMonth(i, true))
	end
end
InGameMenuCalendarFrame.setPeriodTitles = Utils.overwrittenFunction(InGameMenuCalendarFrame.setPeriodTitles, TLInGameMenuCalendarFrameExtension.setPeriodTitles)


function TLInGameMenuCalendarFrameExtension:populateCellForItemInSection(superFunc, list, section, index, cell)
-- print(string.format("TLInGameMenuCalendarFrameExtension:populateCellForItemInSection(%s,%s,%s,%s,%s)", superFunc, list, section, index, cell));
	local fruitDesc = self.fruitTypes[index]
	local fillType = g_fruitTypeManager:getFillTypeByFruitTypeIndex(fruitDesc.index)

	cell:getAttribute("fruitIcon"):setImageFilename(fillType.hudOverlayFilename)
	cell:getAttribute("fruitName"):setText(fillType.title)
	cell:getAttribute("germination"):setText("")

	local plantColor = InGameMenuCalendarFrame.BLOCK_COLORS[self.isColorBlindMode][InGameMenuCalendarFrame.BLOCK_TYPE_PLANTABLE]
	local harvestColor = InGameMenuCalendarFrame.BLOCK_COLORS[self.isColorBlindMode][InGameMenuCalendarFrame.BLOCK_TYPE_HARVESTABLE]

	-- print("fruitDesc.index: " .. tostring(fruitDesc.index))
	-- die monate
	for i = 1, 12 do
		local monthCell = cell:getAttribute("period" .. i)
		
		local plantCell = monthCell.elements[1]
		local plantCells = {}
		local harvestCell = monthCell.elements[2]
		local harvestCells = {}
		
		-- elemente aufsplitten
		if #monthCell.elements == 2 then
			local currentWidth = plantCell.size[1] / 4;
			plantCell.size[1] = currentWidth
			harvestCell.size[1] = currentWidth
			
			-- 3 clone erstellen
			local newPlantCell2 = plantCell:clone(monthCell)
			newPlantCell2.position[1] = currentWidth
			local newPlantCell3 = plantCell:clone(monthCell)
			newPlantCell3.position[1] = currentWidth*2
			local newPlantCell4 = plantCell:clone(monthCell)
			newPlantCell4.position[1] = currentWidth*3
			
			local newHarvestCell2 = harvestCell:clone(monthCell)
			newHarvestCell2.position[1] = currentWidth
			local newHarvestCell3 = harvestCell:clone(monthCell)
			newHarvestCell3.position[1] = currentWidth*2
			local newHarvestCell4 = harvestCell:clone(monthCell)
			newHarvestCell4.position[1] = currentWidth*3
		end
-- TerraLiveExtension.DebugTable("monthCell", monthCell)

		-- jetzt durchlaufen der monats elemente
		plantCells[1] = monthCell.elements[1]
		plantCells[2] = monthCell.elements[3]
		plantCells[3] = monthCell.elements[4]
		plantCells[4] = monthCell.elements[5]
		
		harvestCells[1] = monthCell.elements[2]
		harvestCells[2] = monthCell.elements[6]
		harvestCells[3] = monthCell.elements[7]
		harvestCells[4] = monthCell.elements[8]
		
		for j = 1, 4 do
			local period = ((i - 1) *4) + j
			plantCells[j]:setVisible(g_currentMission.growthSystem:canFruitBePlanted(fruitDesc.index, period))
			plantCells[j]:setImageColor(nil, unpack(plantColor))
			harvestCells[j]:setVisible(g_currentMission.growthSystem:canFruitBeHarvested(fruitDesc.index, period))
			harvestCells[j]:setImageColor(nil, unpack(harvestColor))
		end
	end

	cell.elements[1]:invalidateLayout()
end
InGameMenuCalendarFrame.populateCellForItemInSection = Utils.overwrittenFunction(InGameMenuCalendarFrame.populateCellForItemInSection, TLInGameMenuCalendarFrameExtension.populateCellForItemInSection)

TLInGameMenuGameSettingsFrameExtension = {}
function TLInGameMenuGameSettingsFrameExtension:onFrameOpen(element)
	-- print(string.format("TLInGameMenuGameSettingsFrameExtension:onFrameOpen(%s)", element));
	-- TerraLiveExtension.DebugTable("self.multiPlannedDaysPerPeriod.elements", self.multiPlannedDaysPerPeriod.elements)
	self.multiPlannedDaysPerPeriod:setLabel(g_i18n:getText("TL_setting_plannedDaysPerWeek"));
	self.multiPlannedDaysPerPeriod.elements[6]:setText(g_i18n:getText("TL_toolTip_plannedDaysPerWeek"));
	

	local days = {}

	for i = 1, Environment.MAX_DAYS_PER_PERIOD do
		table.insert(days, self.l10n:formatNumDay(i))
	end

	self.multiPlannedDaysPerPeriod:setTexts(days)
end
InGameMenuGameSettingsFrame.onFrameOpen = Utils.appendedFunction(InGameMenuGameSettingsFrame.onFrameOpen, TLInGameMenuGameSettingsFrameExtension.onFrameOpen)

TLInGameMenuPricesFrameExtension = {}
function TLInGameMenuPricesFrameExtension:updateFluctuations(superFunc)
	local fillTypeDesc = self.fillTypes[self.productList.selectedIndex]
	local originalPrice = fillTypeDesc.pricePerLiter
	local currentPrice = originalPrice
	local totalPrice = 0
	local totalNumPrices = 0

	for _, station in ipairs(self.currentStations) do
		if station.uiIsSelling then
			totalPrice = totalPrice + station:getEffectiveFillTypePrice(fillTypeDesc.index)
			totalNumPrices = totalNumPrices + 1
		end
	end

	if totalNumPrices > 0 then
		currentPrice = totalPrice / totalNumPrices
	end

	local prices = fillTypeDesc.economy.history
	local min = math.huge
	local max = 0

	-- create a temp table with average month data
	local monthAverage = {}
	for i = 1, 12 do
		monthAverage[i] = 0;
		for j = -3, 0 do
			monthAverage[i] = monthAverage[i] + prices[(i*4)+j]
		end
		monthAverage[i] = monthAverage[i] / 4;
	end
	
	for i = 1, Environment.PERIODS_IN_YEAR do
		min = math.min(min, prices[i])
		max = math.max(max, prices[i])
	end

	local minPrice = min * 1000 * EconomyManager.getPriceMultiplier()
	local maxPrice = max * 1000 * EconomyManager.getPriceMultiplier()
	local range = max - min
	min = math.max(min - range * 0.2, 0)
	max = max + range * 0.2
	local hasAnyFluctuations = min ~= max

	self.noFluctuationsText:setVisible(not hasAnyFluctuations)
	self.fluctuationsLayout:setVisible(hasAnyFluctuations)
	self.fluctuationCurrentPrice:setVisible(hasAnyFluctuations)
	self.fluctuationHigh:setVisible(hasAnyFluctuations)
	self.fluctuationHigh:setValue(maxPrice)
	self.fluctuationLow:setVisible(hasAnyFluctuations)
	self.fluctuationLow:setValue(minPrice)

	if not hasAnyFluctuations then
		return
	end

	for month = 1, 12 do
		local barBg = self.fluctuationBars[month]
		local bar = barBg.elements[1]
		local percentageInView = (monthAverage[month] - min) / (max - min)
		local prevPercentageInView = (monthAverage[(month - 2) % 12 + 1] - min) / (max - min)
		local diff = percentageInView - prevPercentageInView

		if diff > 0 then
			barBg:applyProfile("ingameMenuPriceFluctuationBarBgUp")
			bar:applyProfile("ingameMenuPriceFluctuationBarUp")
			barBg:setPosition(nil, prevPercentageInView * barBg.parent.absSize[2])
		else
			barBg:applyProfile("ingameMenuPriceFluctuationBarBgDown")
			bar:applyProfile("ingameMenuPriceFluctuationBarDown")
			barBg:setPosition(nil, percentageInView * barBg.parent.absSize[2])
		end

		barBg:setSize(nil, math.abs(diff) * barBg.parent.absSize[2])
	end

	local currentFactor = currentPrice / EconomyManager.getPriceMultiplier()

	if originalPrice == 0 then
		currentFactor = 1
	end

	local currentPosition = math.max(math.min((currentFactor - min) / (max - min), 1), 0)

	self.fluctuationCurrentPrice:setPosition(nil, currentPosition * (self.fluctuationCurrentPrice.parent.absSize[2] - self.fluctuationsColumn.elements[1].absSize[2]))

	for i = 1, 12 do
		self.fluctuationMonthHeader[i]:setText(g_i18n:formatPeriodAsMonth(i, true))
	end
end
InGameMenuPricesFrame.updateFluctuations = Utils.overwrittenFunction(InGameMenuPricesFrame.updateFluctuations, TLInGameMenuPricesFrameExtension.updateFluctuations)