PrecisionFarmingTLExtension = {}

function PrecisionFarmingTLExtension:loadMap(superFunc, filename)
	-- print(string.format("PrecisionFarmingTLExtension:loadMap(%s, %s)", superFunc, filename));
	if g_modIsLoaded[FS22_precisionFarming.PrecisionFarming.MOD_NAME] then
		if not Utils.getNoNil(getXMLBool(g_savegameXML, "gameSettings.precisionFarming#initialized"), false) then
			self.firstTimeRun = true

			setXMLBool(g_savegameXML, "gameSettings.precisionFarming#initialized", true)
			g_gameSettings:saveToXMLFile(g_savegameXML)
		end

		self.mapFilename = filename
		
		-- TerraLiveExtension.DebugTable("g_currentMission.missionInfo", g_currentMission.missionInfo)
		-- check for XML file in Map Base directory
		local mapXMLFilename = Utils.getFilename(g_currentMission.missionInfo.mapXMLFilename, g_currentMission.baseDirectory)
		local mapDirectory = Utils.getDirectory(mapXMLFilename)
		local configFileNameInMap = Utils.getFilename("$moddir$FS22_TerraLifePlus/xml/terraLifePlus_precisionFarming.xml", mapDirectory);
		if fileExists(configFileNameInMap) then
			Logging.info("PrecisionFarmingTLExtension use '%s'", configFileNameInMap)
			self.configFileName = configFileNameInMap
		else
			self.configFileName = Utils.getFilename("PrecisionFarming.xml", FS22_precisionFarming.PrecisionFarming.BASE_DIRECTORY)
			Logging.info("PrecisionFarmingTLExtension use '%s' because '%s' not found", self.configFileName, configFileNameInMap)
		end
		
		local xmlFile = loadXMLFile("ConfigXML", self.configFileName)

		for i = 1, #self.valueMaps do
			self.valueMaps[i]:loadFromXML(xmlFile, "precisionFarming", FS22_precisionFarming.PrecisionFarming.BASE_DIRECTORY, self.configFileName, filename)
		end

		for i = 1, #self.valueMaps do
			self.valueMaps[i]:postLoad(xmlFile, "precisionFarming", FS22_precisionFarming.PrecisionFarming.BASE_DIRECTORY, self.configFileName, filename)
		end

		self.aiExtension:loadFromXML(xmlFile, "precisionFarming.aiExtension", FS22_precisionFarming.PrecisionFarming.BASE_DIRECTORY, self.configFileName, filename)
		self.fieldInfoDisplayExtension:loadFromXML(xmlFile, "precisionFarming.fieldInfoDisplayExtension", FS22_precisionFarming.PrecisionFarming.BASE_DIRECTORY, self.configFileName, filename)
		self.harvestExtension:loadFromXML(xmlFile, "precisionFarming.harvestExtension", FS22_precisionFarming.PrecisionFarming.BASE_DIRECTORY, self.configFileName, filename)
		self.helplineExtension:loadFromXML(xmlFile, "precisionFarming.helplineExtension", FS22_precisionFarming.PrecisionFarming.BASE_DIRECTORY, self.configFileName, filename)
		self.farmlandStatistics:loadFromXML(xmlFile, "precisionFarming.farmlandStatistics", FS22_precisionFarming.PrecisionFarming.BASE_DIRECTORY, self.configFileName, filename)
		self.additionalFieldBuyInfo:loadFromXML(xmlFile, "precisionFarming.additionalFieldBuyInfo", FS22_precisionFarming.PrecisionFarming.BASE_DIRECTORY, self.configFileName, filename)
		self.cropSensorLinkageData:loadFromXML(xmlFile, "precisionFarming.cropSensorLinkageData", FS22_precisionFarming.PrecisionFarming.BASE_DIRECTORY, self.configFileName, filename)
		self.manureSensorLinkageData:loadFromXML(xmlFile, "precisionFarming.manureSensorLinkageData", FS22_precisionFarming.PrecisionFarming.BASE_DIRECTORY, self.configFileName, filename)
		self.environmentalScore:loadFromXML(xmlFile, "precisionFarming.environmentalScore", FS22_precisionFarming.PrecisionFarming.BASE_DIRECTORY, self.configFileName, filename)
		self.extendedWeedControl:loadFromXML(xmlFile, "precisionFarming.extendedWeedControl", FS22_precisionFarming.PrecisionFarming.BASE_DIRECTORY, self.configFileName, filename)
		delete(xmlFile)
	end
end

FS22_precisionFarming.PrecisionFarming.loadMap = Utils.overwrittenFunction(FS22_precisionFarming.PrecisionFarming.loadMap, PrecisionFarmingTLExtension.loadMap)