FSDensityMapUtilCultivatorExtension = {}

-- vereinfachte lesbare definition
FSDensityMapUtilCultivatorExtension.cultivatorFruitName = "CULTIVATOR";
FSDensityMapUtilCultivatorExtension.PredefinedGroups = {
	GROUP1 = {
		firstGreenCultivatorWorkingState = 5,
		greenGrowTargetState = 6, -- greenGreenings
		yellowGrowTargetState = 6,
		fruits = { "MEADOW", "GRASS", "OILSEEDRADISH", "FIELDGRASS", "HORSEGRASS", "HERBGRASS", "PASTUREGRASS", "ALFALFA", "CLOVER", "CLOVERGRASS", "MUSTARD", "SUMMERMIX", "WINTERMIX", "FLOWERMIX", "MAISMIX", "BETAMAXX", "NFIX", "LANDSBERGERGEMENGE", "SOLARIGOL", "ORCHARDGRASS", "ROADSIDEGRASS", "LANDSCAPEGRASS", "LAWNGRASS" }
	},
	GROUP2 = {
		firstGreenCultivatorWorkingState = 5,
		greenGrowTargetState = 7, -- greenGrain
		yellowGrowTargetState = 8, -- yellowGrain
		fruits = { "WHEAT", "BARLEY", "OAT", "WINTERWHEAT", "WINTERBARLEY", "RYE", "VETCHRYE", "SPELT", "TRITICALE", "LUPINE", "LINSEED" }
	},
	GROUP3 = {
		firstGreenCultivatorWorkingState = 5,
		greenGrowTargetState = 7, -- greenGrain
		yellowGrowTargetState = 9, -- yellowSorghum
		fruits = { "SORGHUM" }
	},
	GROUP4 = {
		firstGreenCultivatorWorkingState = 5,
		greenGrowTargetState = 7, -- greenGrain
		yellowGrowTargetState = 10, -- yellowCanola
		fruits = { "CANOLA" }
	},
	GROUP5 = {
		firstGreenCultivatorWorkingState = 5,
		greenGrowTargetState = 7, -- greenGrain
		yellowGrowTargetState = 11, -- yellowSoybean
		fruits = { "SOYBEAN" }
	},
	GROUP6 = {
		firstGreenCultivatorWorkingState = 5,
		greenGrowTargetState = 12, -- yellowMaize
		yellowGrowTargetState = 12, -- yellowMaize
		fruits = { "MAIZE", "SUNFLOWER", "SILAGEMAIZE", "SILAGESORGHUM" }
	}
}

-- automatisch in eine schnell auswertbare form umwandeln
FSDensityMapUtilCultivatorExtension.fruitAssignments = {};
for name, group in pairs(FSDensityMapUtilCultivatorExtension.PredefinedGroups) do
-- TerraLiveExtension.DebugTable(name, group.fruits)
	for _, fruit in pairs(group.fruits) do
		FSDensityMapUtilCultivatorExtension.fruitAssignments[fruit] = { greenGrowTargetState = group.greenGrowTargetState, yellowGrowTargetState = group.yellowGrowTargetState, firstGreenCultivatorWorkingState = group.firstGreenCultivatorWorkingState}
	end
end
-- TerraLiveExtension.DebugTable("fruitAssignments", FSDensityMapUtilCultivatorExtension.fruitAssignments)



function FSDensityMapUtilCultivatorExtension.updateDiscHarrowArea(startWorldX, superFunc, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, createField, limitFruitDestructionToField, angle, blockedSprayTypeIndex)
	-- print(string.format("FSDensityMapUtilCultivatorExtension.updateDiscHarrowArea(%s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s)", startWorldX, superFunc, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, createField, limitFruitDestructionToField, angle, blockedSprayTypeIndex))

	-- so funktioinert es, dass die frucht sich ändert, aber das muss ja in die filter
	-- local area, _ = FSDensityMapUtil.updateDirectSowingArea(4, startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, FieldGroundType.ROLLED_SEEDBED, angle, 5)

	-- if true then
	-- return 0, 0;
	-- end
	
	createField = Utils.getNoNil(createField, true)
	limitFruitDestructionToField = Utils.getNoNil(limitFruitDestructionToField, true)
	angle = angle or 0
	local functionData = FSDensityMapUtil.functionCache.updateDiscHarrowArea

	if functionData == nil then
		local terrainRootNode = g_currentMission.terrainRootNode
		local fieldGroundSystem = g_currentMission.fieldGroundSystem
		local groundTypeMapId, groundTypeFirstChannel, groundTypeNumChannels = fieldGroundSystem:getDensityMapData(FieldDensityMap.GROUND_TYPE)
		local groundAngleMapId, groundAngleFirstChannel, groundAngleNumChannels = fieldGroundSystem:getDensityMapData(FieldDensityMap.GROUND_ANGLE)
		local stubbleTillageType = fieldGroundSystem:getFieldGroundValue(FieldGroundType.STUBBLE_TILLAGE)
		local stubbleGreenTillageType = fieldGroundSystem:getFieldGroundValue(FieldGroundType.NOTILL)
		local seedbedType = fieldGroundSystem:getFieldGroundValue(FieldGroundType.SEEDBED)
		local sprayLevelMapId, sprayLevelFirstChannel, sprayLevelNumChannels = fieldGroundSystem:getDensityMapData(FieldDensityMap.SPRAY_LEVEL)
		local sprayLevelMaxValue = fieldGroundSystem:getMaxValue(FieldDensityMap.SPRAY_LEVEL)
		functionData = {
			modifier = DensityMapModifier.new(groundTypeMapId, groundTypeFirstChannel, groundTypeNumChannels, terrainRootNode),
			modifierAngle = DensityMapModifier.new(groundAngleMapId, groundAngleFirstChannel, groundAngleNumChannels, terrainRootNode),
			fieldFilter = DensityMapFilter.new(groundTypeMapId, groundTypeFirstChannel, groundTypeNumChannels, terrainRootNode)
		}

		functionData.fieldFilter:setValueCompareParams(DensityValueCompareType.GREATER, 0)

		functionData.seedbedTypeFilter = DensityMapFilter.new(groundTypeMapId, groundTypeFirstChannel, groundTypeNumChannels, terrainRootNode)

		functionData.seedbedTypeFilter:setValueCompareParams(DensityValueCompareType.EQUAL, seedbedType)

		functionData.stubbleTillageFilter = DensityMapFilter.new(groundTypeMapId, groundTypeFirstChannel, groundTypeNumChannels, terrainRootNode)

		functionData.stubbleTillageFilter:setValueCompareParams(DensityValueCompareType.EQUAL, stubbleTillageType)

		functionData.notStubbleTillageFilter = DensityMapFilter.new(groundTypeMapId, groundTypeFirstChannel, groundTypeNumChannels, terrainRootNode)

		functionData.notStubbleTillageFilter:setValueCompareParams(DensityValueCompareType.NOTEQUAL, stubbleTillageType)

		functionData.sprayLevelModifier = DensityMapModifier.new(sprayLevelMapId, sprayLevelFirstChannel, sprayLevelNumChannels, terrainRootNode)
		functionData.sprayLevelFilter = DensityMapFilter.new(sprayLevelMapId, sprayLevelFirstChannel, sprayLevelNumChannels, terrainRootNode)

		functionData.sprayLevelFilter:setValueCompareParams(DensityValueCompareType.BETWEEN, 0, sprayLevelMaxValue - 1)

		functionData.multiModifiers = {}
		functionData.fruitFilter = {}
		functionData.noFruitFilter = nil
		functionData.stubbleTillageType = stubbleTillageType
		functionData.stubbleGreenTillageType = stubbleGreenTillageType
		functionData.seedbedType = seedbedType
		FSDensityMapUtil.functionCache.updateDiscHarrowArea = functionData
	end

	local multiModifiers = functionData.multiModifiers
	local multiModifier = multiModifiers[createField]

	if multiModifier == nil then
		local terrainRootNode = g_currentMission.terrainRootNode
		local fruitModifier, fieldFilter = nil

		if not createField then
			fieldFilter = functionData.fieldFilter
		end

		local sprayLevelFilter = functionData.sprayLevelFilter
		local sprayLevelModifier = functionData.sprayLevelModifier
		multiModifier = DensityMapMultiModifier.new()
		multiModifiers[createField] = multiModifier
		
		local cultivatorFruitType = g_fruitTypeManager:getFruitTypeByName(FSDensityMapUtilCultivatorExtension.cultivatorFruitName) -- must be defined which fruit
		-- TerraLiveExtension.DebugTable("cultivatorFruitType", cultivatorFruitType)
		for index, desc in pairs(g_fruitTypeManager:getFruitTypes()) do
			if desc.terrainDataPlaneId ~= nil then
				if functionData.noFruitFilter == nil then
					functionData.noFruitFilter = DensityMapFilter.new(desc.terrainDataPlaneId, desc.startStateChannel, desc.numStateChannels, terrainRootNode)

					functionData.noFruitFilter:setValueCompareParams(DensityValueCompareType.EQUAL, 0)
					functionData.noFruitFilter:setTypeIndexCompareMode(DensityTypeCompareType.ALWAYS)
				end

				if desc.destruction.canBeDestroyed then
					local fruitFilter = functionData.fruitFilter[index]

					if fruitFilter == nil then
						fruitFilter = DensityMapFilter.new(desc.terrainDataPlaneId, desc.startStateChannel, desc.numStateChannels, terrainRootNode)

						fruitFilter:setValueCompareParams(DensityValueCompareType.GREATER, 1)

						functionData.fruitFilter[index] = fruitFilter
					end

					-- this will make the stubble type when grow state is 1
					-- fruitFilter:setValueCompareParams(DensityValueCompareType.GREATER, 1)
					-- multiModifier:addExecuteSet(functionData.stubbleTillageType, functionData.modifier, fruitFilter, fieldFilter)
					
					-- this will make additional spray level when state is between 2 and numGrowthStates
					fruitFilter:setValueCompareParams(DensityValueCompareType.BETWEEN, 2, desc.numGrowthStates)
					fruitFilter:setTypeIndexCompareMode(DensityTypeCompareType.EQUAL)
					multiModifier:addExecuteAdd(1, sprayLevelModifier, sprayLevelFilter, fruitFilter, fieldFilter)

					if fruitModifier == nil then
						fruitModifier = DensityMapModifier.new(desc.terrainDataPlaneId, desc.startStateChannel, desc.numStateChannels)
					else
						fruitModifier:resetDensityMapAndChannels(desc.terrainDataPlaneId, desc.startStateChannel, desc.numStateChannels)
					end
					
					
					-- try to change the fruit here when green to max state
					if cultivatorFruitType.index ~= index then
						local modifier = DensityMapModifier.new(cultivatorFruitType.terrainDataPlaneId, desc.startStateChannel, desc.numStateChannels, terrainRootNode)
						
						local cultivatorSettings = FSDensityMapUtilCultivatorExtension.fruitAssignments[desc.name]
						if (cultivatorSettings ~= nil) then
							local minYellowState = desc.minHarvestingGrowthState
							if desc.destruction.filterStart ~= nil and desc.destruction.filterStart < desc.minHarvestingGrowthState then
								-- Use yellow stubble tillage for anything which can be destroyed
								-- Otherwise cultivating destroyable states could lead to a mixed green/yellow texture
								minYellowState = desc.destruction.filterStart
							end
							if desc.destruction.state ~= nil and desc.destruction.state < desc.minHarvestingGrowthState then
								-- same reason; some fruit like grasses have their destruction states below destruction filter start
								minYellowState = desc.destruction.state
							end
							-- change to state for green (when grown enough, but not harvest ready yet)
							fruitFilter:setValueCompareParams(DensityValueCompareType.BETWEEN, cultivatorSettings.firstGreenCultivatorWorkingState, minYellowState - 1)
							multiModifier:addExecuteSet(functionData.stubbleGreenTillageType, functionData.modifier, fruitFilter, fieldFilter)
							multiModifier:addExecuteSet(cultivatorSettings.greenGrowTargetState, modifier, fruitFilter, fieldFilter) -- defined in PredefinedGroups

							-- change to state for yellow (harvest ready/ready for haulm topping, withered, mulched, cut or destruction state)
							fruitFilter:setValueCompareParams(DensityValueCompareType.GREATER, minYellowState - 1)
							multiModifier:addExecuteSet(functionData.stubbleTillageType, functionData.modifier, fruitFilter, fieldFilter)
							multiModifier:addExecuteSet(cultivatorSettings.yellowGrowTargetState, modifier, fruitFilter, fieldFilter) -- defined in PredefinedGroups

							-- change to base game cultivator texture when not grown enough
							fruitFilter:setValueCompareParams(DensityValueCompareType.BETWEEN, 0, cultivatorSettings.firstGreenCultivatorWorkingState - 1)
							multiModifier:addExecuteSet(0, fruitModifier, fruitFilter, fieldFilter)
						else
							-- root crops and others: Base Game behavior
							fruitModifier:setNewTypeIndexMode(DensityIndexCompareMode.ZERO)
							fruitFilter:setValueCompareParams(DensityValueCompareType.GREATER, 0)
							
							if limitFruitDestructionToField then
								multiModifier:addExecuteSet(0, fruitModifier, fruitFilter, fieldFilter)
							else
								multiModifier:addExecuteSet(0, fruitModifier, fruitFilter)
							end
						end
					else
						-- When cultivating the cultivator fruit after it has grown: Set to stubble tillage ground and stop growth
						fruitFilter:setValueCompareParams(DensityValueCompareType.GREATER, 12)
						multiModifier:addExecuteSet(functionData.stubbleTillageType, functionData.modifier, fruitFilter, fieldFilter)
						multiModifier:addExecuteSet(0, fruitModifier, fruitFilter, fieldFilter)
					end


					-- here I need to remove the the onces I added for fruitchange, but how?

					-- fruitModifier:setNewTypeIndexMode(DensityIndexCompareMode.ZERO)
					-- fruitFilter:setValueCompareParams(DensityValueCompareType.GREATER, 0)
					
					-- if limitFruitDestructionToField then
						-- multiModifier:addExecuteSet(0, fruitModifier, fruitFilter, fieldFilter)
					-- else
						-- multiModifier:addExecuteSet(0, fruitModifier, fruitFilter)
					-- end
				end
			end
		end

		for i = 1, #g_currentMission.dynamicFoliageLayers do
			local id = g_currentMission.dynamicFoliageLayers[i]
			local numChannels = getTerrainDetailNumChannels(id)
			local modifier = functionData.dynamicFoliageModifier[id]

			if modifier == nil then
				modifier = DensityMapModifier.new(id, 0, numChannels, terrainRootNode)
				functionData.dynamicFoliageModifier[id] = modifier
			end

			multiModifier:addExecuteSet(0, modifier, fieldFilter)
		end
	end

	local modifier = functionData.modifier
	local modifierAngle = functionData.modifierAngle
	local fieldFilter = functionData.fieldFilter
	local seedbedTypeFilter = functionData.seedbedTypeFilter
	local stubbleTillageFilter = functionData.stubbleTillageFilter
	local notStubbleTillageFilter = functionData.notStubbleTillageFilter
	local seedbedType = functionData.seedbedType
	local noFruitFilter = functionData.noFruitFilter

	if createField then
		fieldFilter = nil
	end

	local _, areaBeforeSeedbed, _ = modifier:executeGet(seedbedTypeFilter)
	local _, _, totalArea = modifier:executeGet()

	modifier:setParallelogramWorldCoords(startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, DensityCoordType.POINT_POINT_POINT)
	modifierAngle:setParallelogramWorldCoords(startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, DensityCoordType.POINT_POINT_POINT)
	modifier:executeSet(seedbedType, notStubbleTillageFilter, fieldFilter, noFruitFilter)
	modifierAngle:executeSet(angle, seedbedTypeFilter)
	modifierAngle:executeSet(angle, stubbleTillageFilter)

	local _, areaBeforeStubbleTillage, _ = modifier:executeGet(stubbleTillageFilter)

	multiModifier:updateParallelogramWorldCoords(startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, DensityCoordType.POINT_POINT_POINT)
	multiModifier:execute(false)

	local _, areaAfterSeedbed, _ = modifier:executeGet(seedbedTypeFilter)
	local _, areaAfterStubbleTillage, _ = modifier:executeGet(stubbleTillageFilter)

	FSDensityMapUtil.removeSprayArea(startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, blockedSprayTypeIndex)

	if g_currentMission.missionInfo.weedsEnabled then
		FSDensityMapUtil.setSowingWeedArea(startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, DensityCoordType.POINT_POINT_POINT)
	else
        FSDensityMapUtil.removeWeedArea(startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ)
	end

	DensityMapHeightUtil.clearArea(startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ)

	local changedArea = areaAfterSeedbed - areaBeforeSeedbed + areaAfterStubbleTillage - areaBeforeStubbleTillage

	return changedArea, totalArea
end


FSDensityMapUtil.updateDiscHarrowArea = Utils.overwrittenFunction(FSDensityMapUtil.updateDiscHarrowArea, FSDensityMapUtilCultivatorExtension.updateDiscHarrowArea)