-- Farming Agency Directory Rewrite
-- Allows redirecting into other mods
-- by [F/A] Braeven
-- Version 1.0 - 13.10.2023

-- Only for Use with TerraLife, It is not allowed to use this script without permission from Braeven / Farming Agency

DirectoryRewrite = {}

function DirectoryRewrite.getFilename(filename, superFunc, baseDir)
	-- TerraLiveExtension.DebugText("DirectoryRewrite.getFilename(%s, %s, %s)", filename, superFunc, baseDir)
	if filename == nil then
		printCallstack()

		return nil
	end

	if type(filename) == "boolean" then
		printCallstack()
	end
	
	-- fix for replaced vehicle to load them from the replacement everywhere
	if filename == "$data/vehicles/bredal/k105/k105.xml" then
		filename = "$moddir$FS22_TerraLifePlus_Utils/vehicles/bredal/k105/k105.xml";
	elseif filename == "$data/vehicles/bredal/k165/k165.xml" then
		filename = "$moddir$FS22_TerraLifePlus_Utils/vehicles/bredal/k165/k165.xml";
	end
	
	if filename:sub(1, 8) == "$moddir$" then
		local snippedPath = filename:sub(9, -1)
		local num = 1
		local modName = {}
		for i in string.gmatch(snippedPath, "([^/]+)") do
		 modName[num] = i
		 num = num + 1
		end
		local lenght = string.len(modName[1])
		snippedPath = snippedPath:sub(lenght+2, -1)
		baseDir = g_modNameToDirectory[modName[1]]
		filename = snippedPath
	end
	
	if filename:sub(1, 1) == "$" then
		return filename:sub(2), false
	elseif baseDir == nil or baseDir == "" then
		return filename, false
	elseif filename == "" then
		return filename, true
	end

	return baseDir .. filename, true
end

Utils.getFilename = Utils.overwrittenFunction(Utils.getFilename, DirectoryRewrite.getFilename)