-- Farming Agency Shop Rewrite
-- Removes / Exchanges Items inside the Shop
-- by [F/A] Braeven
-- Version 1.0 - 01.12.2023

-- Only for Use with TerraLife, It is not allowed to use this script without permission from Braeven / Farming Agency

FAShopRewrite = {}

function FAShopRewrite:loadItem(superFunc, rawXMLFilename, baseDir, customEnvironment, isMod, isBundleItem, dlcTitle, extraContentId, ignoreAdd)
	if rawXMLFilename == "$data/objects/bigBagPallet/seeds/multiPurchaseBigBagPallet_seeds.xml" then
		rawXMLFilename = "$moddir$FS22_TerraLifePlus_Assets/xml/MultiBuySeedsUniversalBigBagPallet.xml"
	elseif rawXMLFilename == "$data/objects/bigBag/seeds/multiPurchaseBigBag_seeds.xml" then
		rawXMLFilename = "$moddir$FS22_TerraLifePlus_Assets/xml/MultiBuySeedsUniversalBigBag.xml"
	elseif rawXMLFilename == "$data/objects/pallets/pioneer/pioneerPallet.xml" then
		rawXMLFilename = "$moddir$FS22_TerraLifePlus_Assets/xml/MultiBuySeedsUniversalPallet.xml"
	elseif rawXMLFilename == "$data/objects/bigBag/chickenFood/multiPurchaseBigBag_chickenFood.xml" then
		rawXMLFilename = "$moddir$FS22_TerraLifePlus_Assets/xml/MultiBuyGrainChickenFoodBigBag.xml"
	elseif rawXMLFilename == "$data/objects/bigBagPallet/chickenFood/multiPurchaseBigBagPallet_chickenFood.xml" then
		rawXMLFilename = "$moddir$FS22_TerraLifePlus_Assets/xml/MultiBuyGrainChickenFoodBigBagPallet.xml"
	elseif rawXMLFilename == "$data/objects/bigBagPallet/horseFood/multiPurchaseBigBagPallet_horseFood.xml" then
		rawXMLFilename = "$moddir$FS22_TerraLifePlus_Assets/xml/MultiBuyGrainHorseFoodBigBag.xml"
	elseif rawXMLFilename == "$data/objects/bigBag/horseFood/multiPurchaseBigBag_horseFood.xml" then
		rawXMLFilename = "$moddir$FS22_TerraLifePlus_Assets/xml/MultiBuyGrainHorseFoodBigBagPallet.xml"
	elseif rawXMLFilename == "$data/objects/bigBagPallet/pigFood/multiPurchaseBigBagPallet_pigFood.xml" then
		rawXMLFilename = "$moddir$FS22_TerraLifePlus_Assets/xml/MultiBuyGrainPigFoodBigBagPallet.xml"
	elseif rawXMLFilename == "$data/objects/bigBag/pigFood/multiPurchaseBigBag_pigFood.xml" then
		rawXMLFilename = "$moddir$FS22_TerraLifePlus_Assets/xml/MultiBuyGrainPigFoodBigBag.xml"
	elseif rawXMLFilename == "$data/vehicles/bredal/k105/k105.xml" then
		rawXMLFilename = "$moddir$FS22_TerraLifePlus_Utils/vehicles/bredal/k105/k105.xml"
	elseif rawXMLFilename == "$data/vehicles/bredal/k165/k165.xml" then
		rawXMLFilename = "$moddir$FS22_TerraLifePlus_Utils/vehicles/bredal/k165/k165.xml"
	end

	--Laden der Kaufbaren Ballen verhindern
	if rawXMLFilename == "$data/objects/buyableBales/buyableBales_dryGrass.xml" or rawXMLFilename == "$data/objects/buyableBales/buyableBales_dryGrassRound.xml" or rawXMLFilename == "$data/objects/buyableBales/buyableBales_silage.xml" or rawXMLFilename == "$data/objects/buyableBales/buyableBales_silageRound.xml" or rawXMLFilename == "$data/objects/buyableBales/buyableBales_straw.xml" or rawXMLFilename == "$data/objects/buyableBales/buyableBales_strawRound.xml" then
		return nil
	end
	
	-- Silage Palette laden verhindern
	if rawXMLFilename == "$data/objects/pallets/bonsilage/bonsilagePallet.xml" then
		return nil
	end
		
	return superFunc(self, rawXMLFilename, baseDir, customEnvironment, isMod, isBundleItem, dlcTitle, extraContentId, ignoreAdd)
end

StoreManager.loadItem = Utils.overwrittenFunction(StoreManager.loadItem, FAShopRewrite.loadItem)



function FAShopRewrite.renameDuplicatedConfigurationNames(configurationItems, superFunc, configItem)

	if configItem.name == g_i18n:getText("TL_fillType_seeds") then
	elseif configItem.name == g_i18n:getText("TL_fillType_ccm") then
	else
		return superFunc(configurationItems, configItem)
	end
end

StoreItemUtil.renameDuplicatedConfigurationNames = Utils.overwrittenFunction(StoreItemUtil.renameDuplicatedConfigurationNames, FAShopRewrite.renameDuplicatedConfigurationNames)



--Replace Seedpallet in Starter Packs Premium Expansion
function FAShopRewrite:addPackItem(superFunc, name, itemFilename)
	if itemFilename == "data/objects/pallets/pioneer/pioneerPallet.xml" then
		itemFilename = Utils.getFilename("$moddir$FS22_TerraLifePlus_Assets/xml/MultiBuySeedsUniversalPallet.xml")
	end
	superFunc(self, name, itemFilename)
end

StoreManager.addPackItem = Utils.overwrittenFunction(StoreManager.addPackItem, FAShopRewrite.addPackItem)


--Replace Price with Configure-Text
function FAShopRewrite:getStoreItemDisplayPrice(superFunc, storeItem, item, isSellingOrReturning, saleItem)
	local priceStr = superFunc(self, storeItem, item, isSellingOrReturning, saleItem)
	if storeItem.price == 98765432 then
		priceStr = g_i18n:getText("TL_FAMultiItemPurchase_MultiBuyConfigure")
	end

	return priceStr
end

ShopItemsFrame.getStoreItemDisplayPrice = Utils.overwrittenFunction(ShopItemsFrame.getStoreItemDisplayPrice, FAShopRewrite.getStoreItemDisplayPrice)