TerraLifePlusFermentationManager = {}
local TerraLifePlusFermentationManager_mt = Class(TerraLifePlusFermentationManager)

function TerraLifePlusFermentationManager.new(customMt)
	local self = {}

	setmetatable(self, customMt or TerraLifePlusFermentationManager_mt)

	return self
end

--Einstellung für Fermentation aus TLP Laden
function TerraLifePlusFermentationManager:loadFermentation()
	local fermentation = {}
	local mod = g_modManager:getModByName("FS22_TerraLifePlus")
	local xmlFile = XMLFile.load("TempDesc", mod.modDir.."xml/terraLifePlus_fermentation.xml")
	xmlFile:iterate("terraLifePlus.fermenting", function (_, key)
		local inputFillTypeName = xmlFile:getString(key .. "#inputFillType")
		local inputFillTypeIndex = g_fillTypeManager:getFillTypeIndexByName(inputFillTypeName)
		local outputFillTypeName = xmlFile:getString(key .. "#outputFillType")
		local outputFillTypeIndex = g_fillTypeManager:getFillTypeIndexByName(outputFillTypeName)
		local outputFillTypeUnwrappedName = xmlFile:getString(key .. "#outputFillTypeUnwrapped")
		local outputFillTypeUnwrappedIndex = g_fillTypeManager:getFillTypeIndexByName(outputFillTypeUnwrappedName)
		local requiresWrapping = xmlFile:getBool(key .. "#requiresWrapping", true)
		local timeUnwrapped = xmlFile:getString(key .. "#timeUnwrapped", 0)
		local time = xmlFile:getString(key .. "#time", 0)

		if inputFillTypeIndex ~= nil then
			local fillType = {}
			fillType.outputFillTypeIndex = outputFillTypeIndex
			fillType.outputFillTypeUnwrappedIndex = outputFillTypeUnwrappedIndex
			fillType.timeUnwrapped = timeUnwrapped
			fillType.time = time
			fillType.requiresWrapping = requiresWrapping
			fermentation[inputFillTypeIndex] = fillType
		end
	end)
	xmlFile:delete()
	
    self.fermentation = fermentation
end

g_terraLifePlusFermentationManager = TerraLifePlusFermentationManager.new()
