--add sprayTypes 

function appendLoadGroundTypes(self, filename)

	local function printDebugStuff()
		print("filename: " .. filename)
		print("FieldSprayType All:")
		DebugUtil.printTableRecursively(FieldSprayType.getAll(), "  --", 0, 1)
		print("FieldGroundType All:")
		DebugUtil.printTableRecursively(FieldGroundType.getAll(), "  --", 0, 1)

		print("fieldSprayTypeValue")
		DebugUtil.printTableRecursively(g_currentMission.fieldGroundSystem.fieldSprayTypeValue, "  --", 0, 1)
		print("fieldGroundTypeValue")
		DebugUtil.printTableRecursively(g_currentMission.fieldGroundSystem.fieldGroundTypeValue, "  --", 0, 1)
		print("fieldChopperTypeValue")
		DebugUtil.printTableRecursively(g_currentMission.fieldGroundSystem.fieldChopperTypeValue, "  --", 0, 1)
		
		print("densityMaps")
		DebugUtil.printTableRecursively(g_currentMission.fieldGroundSystem.densityMaps, "  --", 0, 2)

	end

	if filename == 'data/maps/maps_fieldGround.xml' then
		--print("***BEFORE***")
		--printDebugStuff()
	end

	local compost = g_currentMission.fieldGroundSystem:getFieldSprayValueByName("COMPOST")
	
	if compost == 0 then

		local function addNewSprayType(name, identifier, value, colorStr)
		
			FieldSprayType[name] = identifier
			local all = FieldSprayType.getAll()
			all[name] = identifier
			local allOrdered = FieldSprayType.getAllOrdered()
			table.insert(allOrdered, FieldSprayType[name])

			g_currentMission.fieldGroundSystem.fieldSprayTypeValue[identifier] = value
			g_currentMission.fieldGroundSystem.fieldSprayTypeTyreTrackColor[value] = {colorStr:getVector()}

		end
		
		local function addNewGroundType(name, identifier, value, colorStr)
		
			FieldGroundType[name] = identifier
			local all = FieldGroundType.getAll()
			all[name] = identifier
			local allOrdered = FieldGroundType.getAllOrdered()
			table.insert(allOrdered, FieldGroundType[name])

			g_currentMission.fieldGroundSystem.fieldGroundTypeValue[identifier] = value
			g_currentMission.fieldGroundSystem.fieldGroundTypeTyreTrackColor[value] = {colorStr:getVector()}
		
		end
		
		local function addNewChopperType(name, identifier, value, colorStr)
		
			FieldChopperType[name] = identifier
			g_currentMission.fieldGroundSystem.fieldChopperTypeValue[identifier] = value
			g_currentMission.fieldGroundSystem.fieldChopperTypeTyreTrackColor[value] = {colorStr:getVector()}
		
		end
		
		local function getMaxInt(container)
			local maxVal = 0
			for k, v in pairs(container) do
				if type(v) == 'number' then
					if v > maxVal then
						maxVal = v
					end
				end
			end
			return maxVal
		end

		local nSpray = getMaxInt(FieldSprayType)
		local nGround = getMaxInt(FieldGroundType)
		local nChopper = getMaxInt(FieldChopperType)
		local colorStr = "0.123 0.074 0.044 1"
		
		-- SPRAY TYPES
		addNewSprayType('COMPOST', nSpray+1, 7, colorStr)
		addNewSprayType('CARBOLIME', nSpray+2, 8, colorStr)
		addNewSprayType('LIQUIDCARBOLIME', nSpray+3, 9, colorStr)
		
		-- GROUND TYPES
		addNewGroundType('GREENSTUBBLE_TILLAGE', nGround+1, 2, colorStr)
		addNewGroundType('NOTILL', nGround+2, 9, colorStr)
		addNewGroundType('STUBBLE_NOTILL', nGround+3, 10, colorStr)
		addNewGroundType('PLANTED_NARROW', nGround+4, 12, colorStr)
		addNewGroundType('RIDGE_NARROW', nGround+5, 14, colorStr)
		addNewGroundType('LAWN', nGround+6, 20, colorStr)
		
		Wheels.MAX_SINK[FieldGroundType.GREENSTUBBLE_TILLAGE] = 0.15;
		Wheels.MAX_SINK[FieldGroundType.NOTILL] = 0.08;
		Wheels.MAX_SINK[FieldGroundType.STUBBLE_NOTILL] = 0.08;
		Wheels.MAX_SINK[FieldGroundType.PLANTED_NARROW] = 0.08;
		Wheels.MAX_SINK[FieldGroundType.RIDGE_NARROW] = 0.15;
		Wheels.MAX_SINK[FieldGroundType.LAWN] = 0.1;

		-- CHOPPER TYPES
		addNewChopperType('CHOPPER_GREEN', nChopper+1, 10, colorStr)
		

		local allOrderedSpray = FieldSprayType.getAllOrdered()
		table.sort(allOrderedSpray)
		
		local allOrderedGround = FieldGroundType.getAllOrdered()
		table.sort(allOrderedGround)

		local oldFieldSprayTypeGetName = FieldSprayType.getName
		FieldSprayType.getName = function(arg1)
			local value = oldFieldSprayTypeGetName(arg1)
			if value == nil then
				local all = FieldSprayType.getAll()
				for k, v in pairs(all) do
					if v == arg1 then
						value = k
						break
					end
				end
			end
			--print("getName: " .. tostring(arg1) .. " = " .. tostring(value))
			return value or 0
		end
		
		local oldFieldSprayTypeGetByName = FieldSprayType.getByName
		FieldSprayType.getByName = function(arg1)
			print("*** GET BY NAME: " .. tostring(arg1) .. " ***")
			print("  " .. oldFieldSprayTypeGetByName(arg1))
			return oldFieldSprayTypeGetByName(arg1)
		end
		
		-- local oldFieldGroundSystemGetFieldSprayValueByName = FieldGroundSystem.getFieldSprayValueByName
		-- FieldGroundSystem.getFieldSprayValueByName = function(self, sprayTypeName)
			-- local value = oldFieldGroundSystemGetFieldSprayValueByName(self, sprayTypeName)
			-- print("getFieldSprayValueByName: " .. tostring(sprayTypeName) .. " = " .. tostring(value))
			-- return value or 0
		-- end
		
		-- local oldFieldSprayTypeGetAll = FieldSprayType.getAll
		-- FieldSprayType.getAll = function()
			-- print("*** GET ALL ***")
			-- return oldFieldSprayTypeGetAll()
		-- end
		
		-- local oldFieldSprayTypeGetAllOrdered = FieldSprayType.getAllOrdered
		-- FieldSprayType.getAllOrdered = function()
			-- print("*** GET ALL ORDERED ***")
			-- return oldFieldSprayTypeGetAllOrdered()
		-- end
		

	end
	
	if filename ~= 'data/maps/maps_fieldGround.xml' then
		--print("***AFTER***")
		--printDebugStuff()
	end
		
end
FieldGroundSystem.loadGroundTypes = Utils.appendedFunction(FieldGroundSystem.loadGroundTypes, appendLoadGroundTypes)


-- FIX FOR PUMPS AND HOSES SEPARATE MANURE TEXTURE
function appendLoadEffectSpecificDataFromXML(target, xmlFile, key)
	if g_modIsLoaded['pdlc_pumpsAndHosesPack'] then
		-- print("** PumpsAndHosesPack is loaded **")
		if target.fillTypes ~= nil then
			local manureIndex = g_fillTypeManager:getFillTypeIndexByName("MANURE")
			local function tableContainsValue(container, value)
				for k, v in pairs(container) do
					if v == value then
						return true
					end
				end
				return false
			end
			if tableContainsValue(target.fillTypes, manureIndex) then
				local fillTypeIndex = g_fillTypeManager:getFillTypeIndexByName("SEPARATED_MANURE")
				if fillTypeIndex ~= FillType.UNKNOWN then
					-- print("** Adding: SEPARATED_MANURE **")
					table.insert(target.fillTypes, fillTypeIndex)
				end
			end
		end
	end
end
TypedMotionPathEffect.loadEffectSpecificDataFromXML = Utils.appendedFunction(TypedMotionPathEffect.loadEffectSpecificDataFromXML, appendLoadEffectSpecificDataFromXML)


-- INVALIDATE FUNCTION CACHE FOR LIME TEXTURE CHANGES
local oldSprayTypeManagerGetSprayTypeByIndex = SprayTypeManager.getSprayTypeByIndex
SprayTypeManager.getSprayTypeByIndex = function(self, index)
	if index ~= nil then
		local sprayType = self.sprayTypes[index]
		if self.lastSprayType == nil or self.lastSprayType ~= sprayType then
			self.lastSprayType = sprayType
			FSDensityMapUtil.functionCache.updateLimeArea = nil
		end
	end
	return oldSprayTypeManagerGetSprayTypeByIndex(self, index)
end

-- local oldFSDensityMapUtilUpdateSprayArea = FSDensityMapUtil.updateSprayArea
-- FSDensityMapUtil.updateSprayArea = function(sx, sz, wx, wz, hx, hz, sprayType, sprayAmount)
	-- print("sprayType: " .. tostring(sprayType))
	-- return oldFSDensityMapUtilUpdateSprayArea(sx, sz, wx, wz, hx, hz, sprayType, sprayAmount)
-- end