EjectColostrumEvent = {
    EJECT_TO = {
        STORAGE = 0,
        SLURRY = 1
    }
}
local EjectColostrumEvent_mt = Class(EjectColostrumEvent, Event)

InitEventClass(EjectColostrumEvent, "EjectColostrumEvent")

function EjectColostrumEvent.emptyNew()
	local self = Event.new(EjectColostrumEvent_mt)

	return self
end

function EjectColostrumEvent.new(husbandry, ejectTo)
	local self = EjectColostrumEvent.emptyNew()
	self.husbandry = husbandry
    self.ejectTo = ejectTo

	return self
end

function EjectColostrumEvent:readStream(streamId, connection)
	self.husbandry = NetworkUtil.readNodeObject(streamId)
    self.ejectTo = streamReadInt8(streamId)

	self:run(connection)
end

function EjectColostrumEvent:writeStream(streamId, connection)
	NetworkUtil.writeNodeObject(streamId, self.husbandry)
    streamWriteInt8(streamId, self.ejectTo)
end

function EjectColostrumEvent:run(connection)
    if self.ejectTo == EjectColostrumEvent.EJECT_TO.STORAGE then
        self.husbandry:ejectColostrumToStorage()
    elseif self.ejectTo == EjectColostrumEvent.EJECT_TO.SLURRY then
        self.husbandry:ejectColostrumToSlurry()
    else
        Logging.error("EjectColostrumEvent: Eject to option "..self.ejectTo.." not implemented")
    end
end