
PlaceableHusbandryBeddingExtension = {}
function PlaceableHusbandryBeddingExtension:updateOutput(superFunc2, superFunc, cluster, foodFactor, productionFactor, clusterProductionFactor)
	-- print(string.format("PlaceableHusbandryBeddingExtension:updateOutput(%s, %s, %s, %s, %s, %s)", superFunc2, superFunc, cluster, foodFactor, productionFactor, clusterProductionFactor));
	if self.isServer then
		local spec = self.spec_husbandryBedding
		
		local subType = g_currentMission.animalSystem:getSubTypeByIndex(cluster.subTypeIndex)

		-- liter selbst berechnen, damit cluster abhängig
		-- wird in PlaceableHusbandryMilk:onHusbandryAnimalsUpdate(clusters) für alle cluster gesetzt
		local inputLitersPerHour = 0
		local outputLitersPerHour = 0
		if subType ~= nil then
			local straw = subType.input.straw

			if straw ~= nil then
				local age = cluster:getAge()
				local litersPerAnimal = straw:get(age) * 1.5
				local litersPerDay = litersPerAnimal * cluster:getNumAnimals()
				inputLitersPerHour = inputLitersPerHour + litersPerDay / 24
			end
			
			local manure = subType.output.manure

			if manure ~= nil then
				local age = cluster:getAge()
				local litersPerAnimal = manure:get(age)
				local litersPerDay = litersPerAnimal * cluster:getNumAnimals()
				outputLitersPerHour = outputLitersPerHour + litersPerDay / 24
			end
		end

		if outputLitersPerHour > 0 then
			local amount = inputLitersPerHour * g_currentMission.environment.timeAdjustment
			local delta = amount - self:removeHusbandryFillLevel(self:getOwnerFarmId(), amount, spec.inputFillType)

			if outputLitersPerHour > 0 and delta > 0 then
				local liters = foodFactor * math.min(outputLitersPerHour, delta) * g_currentMission.environment.timeAdjustment

				if liters > 0 then
					self:addHusbandryFillLevelFromTool(self:getOwnerFarmId(), liters, spec.outputFillType, nil, ToolType.UNDEFINED, nil)
				end
			end

			self:updatePlane()
		end
	end

	superFunc(self, cluster, foodFactor, productionFactor, clusterProductionFactor)
end

if g_modIsLoaded["pdlc_pumpsAndHosesPack"] then
	print("PlaceableHusbandryBeddingExtension: pdlc_pumpsAndHosesPack found and overwritten");
	pdlc_pumpsAndHosesPack.PlaceableHusbandryBedding.updateOutput = Utils.overwrittenFunction(pdlc_pumpsAndHosesPack.PlaceableHusbandryBedding.updateOutput, PlaceableHusbandryBeddingExtension.updateOutput);
end