PlaceableHusbandryExtension = {
	AnimalsSupportSheepMilk = {
		SHEEP = true
	}
}

function PlaceableHusbandryExtension:onLoad(superFunc, savegame)
    local animalTypeName = self.xmlFile:getValue("placeable.husbandry.animals#type")

	if PlaceableHusbandryColostrum.AnimalsSupportColostrum[animalTypeName] then
		PlaceableHusbandryExtension:addColostrumToFillTypes(self)
	end

	local xmlFile = self.xmlFile
	local key = "placeable.husbandry.unloadingStation"

	local foundone = false
	--Ursprüngliche FillTypes laden und um neue erweitern
	xmlFile:iterate(key..".unloadTrigger", function(index, fillTypeKey)
		local fillTypes = xmlFile:getString(fillTypeKey.."#fillTypes")
		if fillTypes ~= nil then
			local split = string.split(fillTypes, " ")
			for _, fillType in pairs(split) do
				if fillType:upper() == "STRAW" then
					fillTypes = fillTypes.. " BARLEYSTRAW OATSTRAW SPELTSTRAW RYESTRAW TRITICALESTRAW"
					local pnh = g_modIsLoaded["pdlc_pumpsAndHosesPack"]
					if pnh == true then
						fillTypes = fillTypes.." SEPARATED_MANURE"
					end
					xmlFile:setString(fillTypeKey.."#fillTypes", fillTypes)
					foundone = index-1
				end
			end
		end
	end)

	--FillTypeConverter eintragen
	if foundone ~= false then
		xmlFile:setString(key..".unloadTrigger("..foundone..").fillTypeConversion(0)#incomingFillType", "BARLEYSTRAW")
		xmlFile:setString(key..".unloadTrigger("..foundone..").fillTypeConversion(0)#outgoingFillType", "STRAW")
		xmlFile:setFloat(key..".unloadTrigger("..foundone..").fillTypeConversion(0)#ratio", 1)
		xmlFile:setString(key..".unloadTrigger("..foundone..").fillTypeConversion(1)#incomingFillType", "OATSTRAW")
		xmlFile:setString(key..".unloadTrigger("..foundone..").fillTypeConversion(1)#outgoingFillType", "STRAW")
		xmlFile:setFloat(key..".unloadTrigger("..foundone..").fillTypeConversion(1)#ratio", 1)
		xmlFile:setString(key..".unloadTrigger("..foundone..").fillTypeConversion(2)#incomingFillType", "SPELTSTRAW")
		xmlFile:setString(key..".unloadTrigger("..foundone..").fillTypeConversion(2)#outgoingFillType", "STRAW")
		xmlFile:setFloat(key..".unloadTrigger("..foundone..").fillTypeConversion(2)#ratio", 1)
		xmlFile:setString(key..".unloadTrigger("..foundone..").fillTypeConversion(3)#incomingFillType", "RYESTRAW")
		xmlFile:setString(key..".unloadTrigger("..foundone..").fillTypeConversion(3)#outgoingFillType", "STRAW")
		xmlFile:setFloat(key..".unloadTrigger("..foundone..").fillTypeConversion(3)#ratio", 1)
		xmlFile:setString(key..".unloadTrigger("..foundone..").fillTypeConversion(4)#incomingFillType", "TRITICALESTRAW")
		xmlFile:setString(key..".unloadTrigger("..foundone..").fillTypeConversion(4)#outgoingFillType", "STRAW")
		xmlFile:setFloat(key..".unloadTrigger("..foundone..").fillTypeConversion(4)#ratio", 1)
		local pnh = g_modIsLoaded["pdlc_pumpsAndHosesPack"]
		if pnh == true then
			xmlFile:setString(key..".unloadTrigger("..foundone..").fillTypeConversion(5)#incomingFillType", "SEPARATED_MANURE")
			xmlFile:setString(key..".unloadTrigger("..foundone..").fillTypeConversion(5)#outgoingFillType", "STRAW")
			xmlFile:setFloat(key..".unloadTrigger("..foundone..").fillTypeConversion(5)#ratio", 1)
		end
	end
	
	-- Trogerweiterung mit den in der override ausgelesen daten
	if animalDataOverride.TLCorrectHubandriesCapacities == nil then
		-- TerraLiveExtension.DebugText("TerraLife Plus Error: TLCorrectHubandriesCapacities not loaded");
		return;
	end
	
	local animalTypeName = xmlFile:getValue("placeable.husbandry.animals#type")
	local animalAmount = xmlFile:getValue("placeable.husbandry.animals#maxNumAnimals", 1)
	local capacity = xmlFile:getValue("placeable.husbandry.food#capacity", 10)
	-- TerraLiveExtension.DebugText("TLCorrectHubandriesCapacities:(%s,%s,%s)", animalTypeName, animalAmount, capacity);
	-- correct Food values
	if animalDataOverride.TLCorrectHubandriesCapacities[animalTypeName] ~= nil then
		if animalDataOverride.TLCorrectHubandriesCapacities[animalTypeName]["FOOD"] ~= nil then
			-- divide with 4 because of data is in month and we have 4 weeks per month in TL+
			local newCapacity = math.max(capacity, animalAmount * animalDataOverride.TLCorrectHubandriesCapacities[animalTypeName]["FOOD"]) / 4;
			if newCapacity > capacity then
				xmlFile:setValue("placeable.husbandry.food#capacity", math.max(capacity, newCapacity));
				Logging.xmlDevInfo(xmlFile, "Extend FOOD capacity for TL+ from %s to %s", capacity, newCapacity);
			end
		end
	end
		
	-- correct other storage values
	xmlFile:iterate("placeable.husbandry.storage.capacity", function (_, capacityKey)
		local fillTypeName = xmlFile:getValue(capacityKey .. "#fillType")
		fillTypeName = fillTypeName:upper()
		local capacity = xmlFile:getValue(capacityKey .. "#capacity", 10)
		
		if capacity ~= 0 and animalDataOverride.TLCorrectHubandriesCapacities[animalTypeName] ~= nil then
			if animalDataOverride.TLCorrectHubandriesCapacities[animalTypeName][fillTypeName] ~= nil then
			-- divide with 4 because of data is in month and we have 4 weeks per month in TL+
				local newCapacity = math.max(capacity, animalAmount * animalDataOverride.TLCorrectHubandriesCapacities[animalTypeName][fillTypeName]) / 4;
				if newCapacity > capacity then
					xmlFile:setValue(capacityKey .. "#capacity", math.max(capacity, newCapacity))
					Logging.xmlDevInfo(xmlFile, "Extend %s capacity for TL+ from %s to %s", fillTypeName, capacity, newCapacity);
				end
			end
		end
	end)
	
	return superFunc(self, savegame)
end

PlaceableHusbandry.onLoad = Utils.overwrittenFunction(PlaceableHusbandry.onLoad, PlaceableHusbandryExtension.onLoad)

function PlaceableHusbandryExtension:onHourChanged(superFunc, currentHour)
	-- TerraLiveExtension.DebugText("PlaceableHusbandryExtension:onHourChanged(%s, %s)", superFunc, currentHour);
	if self.isServer then
		local spec = self.spec_husbandry
		-- updateFeeding hat als rückgabe alles außer den foodFactor, weil der im cluster steckt.
		-- alles was damit aufgerufen wird muss als factor von foodFactor und cluster.foodFactor aufgerufen werden, damit z.B. fehlendes Wasser die Gesundheit runter bringt
		local allNonFoodFactor = self:updateFeeding()
		-- TerraLiveExtension.DebugText("PlaceableHusbandryExtension:onHourChanged self:updateFeeding() returns '%s'", allNonFoodFactor);
		
		-- updateFeeding macht selbst pro cluster, das muss hier pro cluster gemacht werden
		local clusters = self.spec_husbandryAnimals.clusterSystem:getClusters()
		for _, cluster in ipairs(clusters) do
			-- updateProduction erstellt nur einen productionFaktor basierend ob genug platz da ist, sonst nichts
			local productionFactor = self:updateProduction(cluster.foodFactor * allNonFoodFactor)
			local factor, changePerHour = nil

			if spec.productionThreshold < productionFactor then
				factor = (productionFactor - spec.productionThreshold) / (1 - spec.productionThreshold)
				changePerHour = spec.productionChangePerHourIncrease
			else
				factor = productionFactor / spec.productionThreshold - 1
				changePerHour = spec.productionChangePerHourDecrease
			end

			local delta = changePerHour * factor
			cluster.productionFactor = MathUtil.clamp(cluster.productionFactor + delta, 0, 1)

			self:updateOutput(cluster, cluster.foodFactor * allNonFoodFactor, productionFactor, cluster.productionFactor)
		end
		self:raiseDirtyFlags(spec.dirtyFlag)
		-- TerraLiveExtension.DebugTable("ClusterCheck", clusters)
	end
end
PlaceableHusbandry.onHourChanged = Utils.overwrittenFunction(PlaceableHusbandry.onHourChanged, PlaceableHusbandryExtension.onHourChanged)


function PlaceableHusbandryExtension:updateOutput(superFunc, cluster, foodFactor, productionFactor, clusterProductionFactor)
	--print(string.format("PlaceableHusbandryExtension:updateOutput(%s, %s, %s, %s, %s)", superFunc, cluster, foodFactor, productionFactor, clusterProductionFactor));
end
PlaceableHusbandry.updateOutput = Utils.overwrittenFunction(PlaceableHusbandry.updateOutput, PlaceableHusbandryExtension.updateOutput)

--Overwrite für Straw Harvest
function PlaceableHusbandryExtension:updateOutputSH(superFunc, cluster, foodFactor, productionFactor, clusterProductionFactor)
	if self.isServer then
		local spec = self.spec_husbandryBeddingMulti

		if spec.inputLitersPerHour > 0 then
			local amount = spec.inputLitersPerHour * g_currentMission.environment.timeAdjustment
			local delta = 0

			for _, inputFillType in ipairs(spec.inputFillTypes) do
				local fillTypeDelta = amount - self:removeHusbandryFillLevel(self:getOwnerFarmId(), amount, inputFillType)
				amount = amount - fillTypeDelta
				delta = delta + fillTypeDelta

				if amount <= 0 then
					break
				end
			end

			if spec.outputLitersPerHour > 0 and delta > 0 then
				local liters = foodFactor * math.min(spec.outputLitersPerHour, delta) * g_currentMission.environment.timeAdjustment

				if liters > 0 then
					self:addHusbandryFillLevelFromTool(self:getOwnerFarmId(), liters, spec.outputFillType, nil, ToolType.UNDEFINED, nil)
				end
			end

			self:updatePlane()
		end
	end

	local spec_husbandryBedding = self.spec_husbandryBedding

	if spec_husbandryBedding ~= nil then
		spec_husbandryBedding.inputLitersPerHour = 0
		spec_husbandryBedding.outputLitersPerHour = 0
	end
	superFunc(self, cluster, foodFactor, productionFactor, clusterProductionFactor)
end

function PlaceableHusbandryExtension:editSH()
	local mod = g_modIsLoaded["FS22_strawHarvestPack"]
	if mod == true then
		local SH = getfenv(0)["FS22_strawHarvestPack"]
		SH.PlaceableHusbandryBeddingMulti.updateOutput = PlaceableHusbandryExtension.updateOutputSH
	end
end

TypeManager.finalizeTypes = Utils.prependedFunction(TypeManager.finalizeTypes, PlaceableHusbandryExtension.editSH)

function PlaceableHusbandryExtension:addColostrumToFillTypes(husbandry)
	local xmlFile = husbandry.xmlFile

    local fillTypes = xmlFile:getValue("placeable.husbandry.storage#fillTypes")
    if not string.find(fillTypes, "COLOSTRUM") then
        fillTypes = fillTypes.." COLOSTRUM"
        xmlFile:setString("placeable.husbandry.storage#fillTypes", fillTypes)
    end

    local capacityIndex = 0
    xmlFile:iterate("placeable.husbandry.storage.capacity", function (index, key)
        capacityIndex = capacityIndex + 1
    end)

    xmlFile:setString("placeable.husbandry.storage.capacity("..capacityIndex..")#fillType", "COLOSTRUM")
    xmlFile:setInt("placeable.husbandry.storage.capacity("..capacityIndex..")#capacity", 3000)
	
	xmlFile:iterate("placeable.husbandry.unloadingStation.unloadTrigger", function (index, key)
        local fillTypes = xmlFile:getValue(key .. "#fillTypes")
        if (string.find(fillTypes, "MILK") or string.find(fillTypes, "HAYMILK")) and not string.find(fillTypes, "COLOSTRUM") then
            fillTypes = fillTypes.." COLOSTRUM"
            xmlFile:setString(key .. "#fillTypes", fillTypes)
        end
	end)

    xmlFile:iterate("placeable.husbandry.loadingStation.loadTrigger", function (index, key)
        local fillTypes = xmlFile:getValue(key .. "#fillTypes")
        if fillTypes ~= nil and (string.find(fillTypes, "MILK") or string.find(fillTypes, "HAYMILK")) and not string.find(fillTypes, "COLOSTRUM") then
            fillTypes = fillTypes.." COLOSTRUM"
            xmlFile:setString(key .. "#fillTypes", fillTypes)
        end
	end)
end
