PlaceableHusbandryLiquidManureExtension = {}
function PlaceableHusbandryLiquidManureExtension:updateOutput(superFunc2, superFunc, cluster, foodFactor, productionFactor, clusterProductionFactor)
	--print(string.format("PlaceableHusbandryLiquidManureExtension:updateOutput(%s, %s, %s, %s, %s, %s)", superFunc2, superFunc, cluster, foodFactor, productionFactor, clusterProductionFactor));
	if self.isServer then
		local spec = self.spec_husbandryLiquidManure
		
		-- liter selbst berechnen, damit cluster abhängig
		-- wird in PlaceableHusbandryLiquidManure:onHusbandryAnimalsUpdate(clusters) für alle cluster gesetzt
		local litersPerHour = 0
		local subType = g_currentMission.animalSystem:getSubTypeByIndex(cluster.subTypeIndex)
		if subType ~= nil then
			local liquidManure = subType.output.liquidManure

			if liquidManure ~= nil then
				local age = cluster:getAge()
				local litersPerAnimal = liquidManure:get(age)
				local litersPerDay = litersPerAnimal * cluster:getNumAnimals()
				litersPerHour = litersPerHour + litersPerDay / 24
			end
		end

		if litersPerHour > 0 then
			local liters = foodFactor * litersPerHour * g_currentMission.environment.timeAdjustment

			self:addHusbandryFillLevelFromTool(self:getOwnerFarmId(), liters, spec.fillType, nil, nil, nil)
		end
	end

	superFunc(self, cluster, foodFactor, productionFactor, clusterProductionFactor)
end
PlaceableHusbandryLiquidManure.updateOutput = Utils.overwrittenFunction(PlaceableHusbandryLiquidManure.updateOutput, PlaceableHusbandryLiquidManureExtension.updateOutput)
