PlaceableHusbandryPalletsExtension = {}
function PlaceableHusbandryPalletsExtension:updateOutput(superFunc2, superFunc, cluster, foodFactor, productionFactor, clusterProductionFactor)
	--print(string.format("PlaceableHusbandryPalletsExtension:updateOutput(%s, %s, %s, %s, %s, %s)", superFunc2, superFunc, cluster, foodFactor, productionFactor, clusterProductionFactor));
	superFunc(self, cluster, foodFactor, productionFactor, clusterProductionFactor)

	local spec = self.spec_husbandryPallets
	spec.showedWarning = false
	
	-- liter selbst berechnen, damit cluster abhängig
	-- wird in PlaceableHusbandryPallets:onHusbandryAnimalsUpdate(clusters) für alle cluster gesetzt
	local subType = g_currentMission.animalSystem:getSubTypeByIndex(cluster.subTypeIndex)
	local litersPerHour = 0
	if subType ~= nil then
		local pallets = subType.output.pallets

		if pallets ~= nil then
			local age = cluster:getAge()
			local litersPerAnimal = pallets:get(age)
			local litersPerDay = litersPerAnimal * cluster:getNumAnimals()
			litersPerHour = litersPerHour + litersPerDay / 24
		end
	end

	if self.isServer and (litersPerHour > 0 or self.spec_husbandryGoatMilk ~= nil) then
		spec.pendingLiters = spec.pendingLiters + productionFactor * clusterProductionFactor * litersPerHour * g_currentMission.environment.timeAdjustment

		self:updatePallets()
		self:raiseDirtyFlags(spec.dirtyFlag)
	end
end
PlaceableHusbandryPallets.updateOutput = Utils.overwrittenFunction(PlaceableHusbandryPallets.updateOutput, PlaceableHusbandryPalletsExtension.updateOutput)
