PlaceableHusbandryWaterExtension = {}

function PlaceableHusbandryWaterExtension:getConditionInfos(superFunc2, superFunc)
	local infos = superFunc(self)
	local spec = self.spec_husbandryWater

	if not spec.automaticWaterSupply then
		local info = {}
		local fillType = g_fillTypeManager:getFillTypeByIndex(spec.fillType)
		info.title = fillType.title
		info.value = self:getHusbandryFillLevel(spec.fillType)
		local capacity = self:getHusbandryCapacity(spec.fillType)
		info.valueText = g_i18n:formatNumber(info.value, 0) .. " / " .. g_i18n:formatVolume(capacity, 0);
		local ratio = 0

		if capacity > 0 then
			ratio = info.value / capacity
		end

		info.ratio = MathUtil.clamp(ratio, 0, 1)
		info.invertedBar = false

		table.insert(infos, info)
	end

	return infos
end
PlaceableHusbandryWater.getConditionInfos = Utils.overwrittenFunction(PlaceableHusbandryWater.getConditionInfos, PlaceableHusbandryWaterExtension.getConditionInfos)