AnimalItemStockExtension = {}

function AnimalItemStockExtension.new(cluster, superFunc)
	local self = superFunc(cluster);

	
	if cluster.numAnimals ~= nil and cluster.numAnimals >= 2 then
		table.insert(self.infos, {
			title = g_i18n:getText("infohud_numAnimals"),
			value = cluster.numAnimals
		})
	end
	
	if cluster.milkBonus ~= nil and cluster.milkBonus ~= 0 then
		table.insert(self.infos, {
			title = g_i18n:getText("statistic_milkProductivity"),
			value = string.format("%.f%%", self.cluster.milkBonus * 100)
		})
	end
	
	if cluster.fatteningBonus ~= nil and cluster.fatteningBonus ~= 0 then
		table.insert(self.infos, {
			title = g_i18n:getText("statistic_fatteningBonus"),
			value = string.format("%.f%%", cluster.fatteningBonus * 100)
		})
	end	
	
	return self
end

AnimalItemStock.new = Utils.overwrittenFunction(AnimalItemStock.new, AnimalItemStockExtension.new)