cutterFix = {}


function cutterFix:readCutterFromStream(superFunc, streamId, connection)
	local spec = self.spec_cutter
	spec.currentGrowthState = streamReadUIntN(streamId, FruitTypeManager.SEND_NUM_BITS)
	spec.currentInputFruitType = streamReadUIntN(streamId, FruitTypeManager.SEND_NUM_BITS)

	if streamReadBool(streamId) then
		spec.lastValidInputFruitType = spec.currentInputFruitType
	else
		spec.currentInputFruitType = FruitType.UNKNOWN
	end

	spec.currentOutputFillType = g_fruitTypeManager:getFillTypeIndexByFruitTypeIndex(spec.currentInputFruitType)

	if spec.fruitTypeConverters[spec.currentInputFruitType] ~= nil then
		spec.currentOutputFillType = spec.fruitTypeConverters[spec.currentInputFruitType].fillTypeIndex
		spec.currentConversionFactor = spec.fruitTypeConverters[spec.currentInputFruitType].conversionFactor
	end

	if streamReadBool(streamId) then
		spec.currentInputFillType = g_fruitTypeManager:getWindrowFillTypeIndexByFruitTypeIndex(spec.currentInputFruitType)
	else
		spec.currentInputFillType = g_fruitTypeManager:getFillTypeIndexByFruitTypeIndex(spec.currentInputFruitType)
	end
end


Cutter.readCutterFromStream = Utils.overwrittenFunction(Cutter.readCutterFromStream, cutterFix.readCutterFromStream)

function cutterFix:writeCutterToStream(superFunc, streamId, connection)
	local spec = self.spec_cutter

	streamWriteUIntN(streamId, spec.currentGrowthState, FruitTypeManager.SEND_NUM_BITS)
	streamWriteUIntN(streamId, spec.currentInputFruitType, FruitTypeManager.SEND_NUM_BITS)
	streamWriteBool(streamId, spec.currentInputFruitType == spec.lastValidInputFruitType)
	streamWriteBool(streamId, spec.useWindrow)
end

Cutter.writeCutterToStream = Utils.overwrittenFunction(Cutter.writeCutterToStream, cutterFix.writeCutterToStream)