InGameNotification = {}

local InGameNotification_mt = Class(InGameNotification, Event)
InitEventClass(InGameNotification, "InGameNotification")

InGameNotification.TYPE = {
    INFO = 1,
    OK = 2,
    CRITICAL = 3
}

function InGameNotification.emptyNew()
    local self = Event.new(InGameNotification_mt)

    return self
end

function InGameNotification.new(notificationType, msg, farmId)
    local self = InGameNotification.emptyNew()

    self.notificationType = notificationType
    self.msg = msg
    self.farmId = farmId

    return self
end

function InGameNotification:readStream(streamId, connection)
    self.notificationType = streamReadInt8(streamId)
    self.msg = streamReadString(streamId)
    self.farmId = streamReadInt8(streamId)

    self:run(connection)
end

function InGameNotification:writeStream(streamId, connection)
    streamWriteInt8(streamId, self.notificationType)
    streamWriteString(streamId, self.msg)
    streamWriteInt8(streamId, self.farmId)
end

function InGameNotification:run(connection)
    local notificationType = FSBaseMission.INGAME_NOTIFICATION_INFO

    if self.notificationType == InGameNotification.TYPE.OK then
        notificationType = FSBaseMission.INGAME_NOTIFICATION_OK
    elseif self.notificationType == InGameNotification.TYPE.CRITICAL then
        notificationType = FSBaseMission.INGAME_NOTIFICATION_CRITICAL
    end

    if self.farmId ~= nil then
        if g_currentMission.player.farmId == self.farmId then
            g_currentMission:addIngameNotification(notificationType, self.msg)
        end
    else
        g_currentMission:addIngameNotification(notificationType, self.msg)
    end

    if not connection:getIsServer() then
        g_server:broadcastEvent(InGameNotification.new(self.notificationType, self.msg, self.farmId), false)
    end
end