
TLFieldManagerExtension = {}

--[[
This function is overwritten because giants only test the fields for state 0 to 15. But in TL+ we have up to 31 states.
So the fields which are e.g. loaded from save game do no know which fruit is on the field and which state.
This will fix a lot of problems with the missions and other stuff.
--]]
function TLFieldManagerExtension:findFieldFruit(superFunc, field)
	if field.fieldMissionAllowed then
		local x, z = FieldUtil.getMeasurementPositionOfField(field)

		local function testFruit(fruitType)
			local minState = 0
			local maxState = 31
			local area, totalArea = FieldUtil.getFruitArea(x - 1, z - 1, x + 1, z - 1, x - 1, z + 1, FieldUtil.FILTER_EMPTY, FieldUtil.FILTER_EMPTY, fruitType, minState, maxState, 0, 0, 0, false)

			return area > 0.5 * totalArea
		end

		for _, fruitType in ipairs(self.availableFruitTypeIndices) do
			if testFruit(fruitType) then
				field.fruitType = fruitType

				break
			end
		end

		if testFruit(FruitType.GRASS) then
			field.fruitType = FruitType.GRASS
		elseif testFruit(FruitType.CLOVERGRASS) then
			field.fruitType = FruitType.CLOVERGRASS
		elseif testFruit(FruitType.MEADOW) then
			field.fruitType = FruitType.MEADOW
		elseif testFruit(FruitType.HORSEGRASS) then
			field.fruitType = FruitType.HORSEGRASS
		elseif testFruit(FruitType.FIELDGRASS) then
			field.fruitType = FruitType.FIELDGRASS
		elseif testFruit(FruitType.HERBGRASS) then
			field.fruitType = FruitType.HERBGRASS
		elseif testFruit(FruitType.ALFALFA) then
			field.fruitType = FruitType.ALFALFA
		elseif testFruit(FruitType.CLOVER) then
			field.fruitType = FruitType.CLOVER
		end
	end
end
FieldManager.findFieldFruit = Utils.overwrittenFunction(FieldManager.findFieldFruit, TLFieldManagerExtension.findFieldFruit)