
FruitDestructionReloadedFSBaseMissionExtension = {}

--[[Currently dead code
function FruitDestructionReloadedFSBaseMissionExtension:onLoadMapFinished(node, failedReason, arguments, callAsyncCallback)
	local modififruits = {"WHEAT","BARLEY","OAT","RYE","SPELT","TRITICALE","SOYBEAN","CANOLA","MILLET","GREENING01","GREENING02","GREENING03","ROADSIDEGRASS","LANDSCAPEGRASS"}
	g_currentMission.fruitDestructionReloadedlist = {}
	local fruitDestructionReloadedlist = {}
    for index, fruit in pairs(g_fruitTypeManager:getFruitTypes()) do
		for _, fruitname in pairs(modififruits) do
			if g_fruitTypeManager:getFruitTypeByIndex(index).name == fruitname then
				fruitDestructionReloadedlist[index] = true
			end
		end
	end
	g_currentMission.fruitDestructionReloadedlist = fruitDestructionReloadedlist
	
	-- Das geht nicht, weil das erst geladen wird, wenn darauf zum ersten mal zugegriffen wird, verschieben
	--FSDensityMapUtil.functionCache.updateWheelDestructionArea.newfilter = false
end
]]

FSDensityMapUtilExtension = {}
function FSDensityMapUtilExtension.updateWheelDestructionArea(startWorldX, superFunc, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ)
	-- print(string.format("FSDensityMapUtilExtension.updateWheelDestructionArea(%s, %s, %s, %s, %s, %s, %s)", startWorldX, superFunc, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ))
	local functionData = FSDensityMapUtil.functionCache.updateWheelDestructionArea

	if functionData == nil then
		local terrainRootNode = g_currentMission.terrainRootNode
		local fieldGroundSystem = g_currentMission.fieldGroundSystem
		local groundTypeMapId, groundTypeFirstChannel, groundTypeNumChannels = fieldGroundSystem:getDensityMapData(FieldDensityMap.GROUND_TYPE)
		local sprayTypeMapId, sprayTypeFirstChannel, sprayTypeNumChannels = fieldGroundSystem:getDensityMapData(FieldDensityMap.SPRAY_TYPE)
		functionData = {
			modifier = DensityMapModifier.new(sprayTypeMapId, sprayTypeFirstChannel, sprayTypeNumChannels, terrainRootNode),
			multiModifier = nil,
			filter1 = DensityMapFilter.new(groundTypeMapId, groundTypeFirstChannel, groundTypeNumChannels, terrainRootNode),
			filter2 = DensityMapFilter.new(groundTypeMapId, groundTypeFirstChannel, groundTypeNumChannels, terrainRootNode),
			filter3 = DensityMapFilter.new(groundTypeMapId, groundTypeFirstChannel, groundTypeNumChannels, terrainRootNode)
		}

		functionData.filter2:setValueCompareParams(DensityValueCompareType.GREATER, 0)

		FSDensityMapUtil.functionCache.updateWheelDestructionArea = functionData
	end

	local modifier = functionData.modifier
	local multiModifier = functionData.multiModifier
	local filter1 = functionData.filter1
	local filter2 = functionData.filter2
	local filter3 = functionData.filter3

	g_currentMission.growthSystem:setIgnoreDensityChanges(true)

	if multiModifier == nil then
		multiModifier = DensityMapMultiModifier.new()
		functionData.multiModifier = multiModifier

		for _, desc in pairs(g_fruitTypeManager:getFruitTypes()) do
			if desc.terrainDataPlaneId ~= nil and (desc.destruction.filterStart ~= nil or desc.destructionPlus.filterStart ~= nil) then
				modifier:resetDensityMapAndChannels(desc.terrainDataPlaneId, desc.startStateChannel, desc.numStateChannels)
				
				if desc.destruction.filterStart ~= nil then
					filter1:resetDensityMapAndChannels(desc.terrainDataPlaneId, desc.startStateChannel, desc.numStateChannels)

					local onlyOnFieldFilter = nil

					if desc.destruction.onlyOnField then
						onlyOnFieldFilter = filter2
					end
					
					filter1:setValueCompareParams(DensityValueCompareType.BETWEEN, desc.destruction.filterStart, desc.destruction.filterEnd)
					multiModifier:addExecuteSet(desc.destruction.state, modifier, filter1, onlyOnFieldFilter)
				end
				
				if desc.destructionPlus.filterStart ~= nil then
					filter3:resetDensityMapAndChannels(desc.terrainDataPlaneId, desc.startStateChannel, desc.numStateChannels)

					local onlyOnFieldFilter = nil

					if desc.destructionPlus.onlyOnField then
						onlyOnFieldFilter = filter2
					end
					
					filter3:setValueCompareParams(DensityValueCompareType.BETWEEN, desc.destructionPlus.filterStart, desc.destructionPlus.filterEnd)
					multiModifier:addExecuteSet(desc.destructionPlus.state, modifier, filter3, onlyOnFieldFilter)
				end

			end
		end

		for i = 1, #g_currentMission.dynamicFoliageLayers do
			local id = g_currentMission.dynamicFoliageLayers[i]
			local numChannels = getTerrainDetailNumChannels(id)

			modifier:resetDensityMapAndChannels(id, 0, numChannels)
			multiModifier:addExecuteSet(0, modifier)
		end
	end

	multiModifier:updateParallelogramWorldCoords(startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, DensityCoordType.POINT_POINT_POINT)
	multiModifier:execute(false)
	FSDensityMapUtil.removeWeedArea(startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ)
	g_currentMission.growthSystem:setIgnoreDensityChanges(false)
end

-- überschrieben damit Striegel alle windrows weg machen
function FSDensityMapUtilExtension.updateWeederArea(startWorldX, superFunc, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, isHoeWeeder)
	-- print(string.format("FSDensityMapUtilExtension.updateWeederArea(%s, %s, %s, %s, %s, %s, %s, %s)", startWorldX, superFunc, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, isHoeWeeder))
	
	local weedSystem = g_currentMission.weedSystem
	local _ = nil
	local areaBefore = 0
	local areaAfter = 0

	if weedSystem:getMapHasWeed() then
		local functionData = FSDensityMapUtil.functionCache.updateWeederArea

		if functionData == nil then
			functionData = {}
			FSDensityMapUtil.functionCache.updateWeederArea = functionData
		end

		local weederData = functionData[isHoeWeeder]

		if weederData == nil then
			local terrainRootNode = g_currentMission.terrainRootNode
			local fieldGroundSystem = g_currentMission.fieldGroundSystem
			local weedMapId, weedFirstChannel, weedNumChannels = weedSystem:getDensityMapData()
			local replacementData = weedSystem:getWeederReplacements(isHoeWeeder)
			local groundTypeMapId, groundTypeFirstChannel, groundTypeNumChannels = fieldGroundSystem:getDensityMapData(FieldDensityMap.GROUND_TYPE)
			local firstSowableState, lastSowableState = fieldGroundSystem:getSowableRange()
			weederData = {
				weedModifier = DensityMapModifier.new(weedMapId, weedFirstChannel, weedNumChannels, terrainRootNode),
				allWeedFilter = DensityMapFilter.new(weedMapId, weedFirstChannel, weedNumChannels, terrainRootNode)
			}

			weederData.allWeedFilter:setValueCompareParams(DensityValueCompareType.GREATER, 0)

			weederData.multiModifierGrowing = DensityMapMultiModifier.new()
			weederData.multiModifierSowable = DensityMapMultiModifier.new()
			local fruitStateFilter = nil
			local sourceStateFilter = DensityMapFilter.new(weedMapId, weedFirstChannel, weedNumChannels, terrainRootNode)
			local sowableFilter = DensityMapFilter.new(groundTypeMapId, groundTypeFirstChannel, groundTypeNumChannels)

			sowableFilter:setValueCompareParams(DensityValueCompareType.BETWEEN, firstSowableState, lastSowableState)

			for sourceState, targetState in pairs(replacementData.weed.replacements) do
				sourceStateFilter:setValueCompareParams(DensityValueCompareType.EQUAL, sourceState)

				for _, desc in pairs(g_fruitTypeManager:getFruitTypes()) do
					if fruitStateFilter == nil then
						fruitStateFilter = DensityMapFilter.new(desc.terrainDataPlaneId, desc.startStateChannel, desc.numStateChannels, terrainRootNode)
					else
						-- Print zum finden welche Früchte einen Fehler machen mit dem Striegel. Nur rein machen zum testen
						-- print(string.format("fruitStateFilter:resetDensityMapAndChannels(%s, %s, %s)", sourceState, targetState, desc.name))
						fruitStateFilter:resetDensityMapAndChannels(desc.terrainDataPlaneId, desc.startStateChannel, desc.numStateChannels, terrainRootNode)
					end

					local maxWeederState = desc.maxWeederState

					if isHoeWeeder then
						maxWeederState = desc.maxWeederHoeState
					end

					fruitStateFilter:setValueCompareParams(DensityValueCompareType.BETWEEN, 0, maxWeederState)
					weederData.multiModifierGrowing:addExecuteSet(targetState, weederData.weedModifier, sourceStateFilter, fruitStateFilter)
					fruitStateFilter:setValueCompareParams(DensityValueCompareType.EQUAL, desc.cutState)
					weederData.multiModifierGrowing:addExecuteSet(targetState, weederData.weedModifier, sourceStateFilter, fruitStateFilter)
				end

				weederData.multiModifierSowable:addExecuteSet(targetState, weederData.weedModifier, sourceStateFilter, sowableFilter)
			end

			if replacementData.custom ~= nil then
				weederData.multiModifierCustom = DensityMapMultiModifier.new()
				local fruitModifier = nil

				for _, data in ipairs(replacementData.custom) do
					local desc = data.fruitType

					if desc.terrainDataPlaneId ~= nil then
						if fruitModifier == nil then
							fruitModifier = DensityMapModifier.new(desc.terrainDataPlaneId, desc.startStateChannel, desc.numStateChannels, terrainRootNode)
						else
							fruitModifier:resetDensityMapAndChannels(desc.terrainDataPlaneId, desc.startStateChannel, desc.numStateChannels, terrainRootNode)
						end

						sourceStateFilter:resetDensityMapAndChannels(desc.terrainDataPlaneId, desc.startStateChannel, desc.numStateChannels, terrainRootNode)

						for sourceState, targetState in pairs(data.replacements) do
							sourceStateFilter:setValueCompareParams(DensityValueCompareType.EQUAL, sourceState)
							weederData.multiModifierCustom:addExecuteSet(targetState, fruitModifier, sourceStateFilter)
						end
					end
				end
			end

			FSDensityMapUtil.functionCache.updateWeederArea[isHoeWeeder] = weederData
		end

		local weedModifier = weederData.weedModifier
		local allWeedFilter = weederData.allWeedFilter
		local multiModifierGrowing = weederData.multiModifierGrowing
		local multiModifierSowable = weederData.multiModifierSowable
		local multiModifierCustom = weederData.multiModifierCustom

		weedModifier:setParallelogramWorldCoords(startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, DensityCoordType.POINT_POINT_POINT)

		_, areaBefore, _ = weedModifier:executeGet(allWeedFilter)

		multiModifierGrowing:updateParallelogramWorldCoords(startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, DensityCoordType.POINT_POINT_POINT)
		multiModifierGrowing:execute(false)
		multiModifierSowable:updateParallelogramWorldCoords(startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, DensityCoordType.POINT_POINT_POINT)
		multiModifierSowable:execute(false)

		if multiModifierCustom ~= nil then
			multiModifierCustom:updateParallelogramWorldCoords(startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, DensityCoordType.POINT_POINT_POINT)
			multiModifierCustom:execute(false)
		end

		_, areaAfter, _ = weedModifier:executeGet(allWeedFilter)
	end

	-- DensityMapHeightUtil.removeFromGroundByArea(startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, FillType.GRASS_WINDROW)
	-- DensityMapHeightUtil.removeFromGroundByArea(startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, FillType.DRYGRASS_WINDROW)
	
	local fillTypes = g_fillTypeManager:getFillTypesByCategoryNames("WINDROW", "Warning: FSDensityMapUtilExtension.updateWeederArea has invalid fillTypeCategory '%s'.");
	
	for _, fillType in pairs(fillTypes) do
		DensityMapHeightUtil.removeFromGroundByArea(startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, fillType);
	end
	
	local fillTypes = g_fillTypeManager:getFillTypesByCategoryNames("WINDROW_NO_BALE", "Warning: FSDensityMapUtilExtension.updateWeederArea has invalid fillTypeCategory '%s'.");
	
	for _, fillType in pairs(fillTypes) do
		DensityMapHeightUtil.removeFromGroundByArea(startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, fillType);
	end
	
	return areaBefore - areaAfter
end


function FSDensityMapUtilExtension.updateGrassRollerArea(startWorldX, superFunc, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, removeStones)
	local functionData = FSDensityMapUtil.functionCache.updateGrassRollerArea

	if functionData == nil then
		local terrainRootNode = g_currentMission.terrainRootNode
		local fieldGroundSystem = g_currentMission.fieldGroundSystem
		local sprayLevelMapId, sprayLevelFirstChannel, sprayLevelNumChannels = fieldGroundSystem:getDensityMapData(FieldDensityMap.SPRAY_LEVEL)
		local groundTypeMapId, groundTypeFirstChannel, groundTypeNumChannels = fieldGroundSystem:getDensityMapData(FieldDensityMap.GROUND_TYPE)
		local sprayTypeMapId, sprayTypeFirstChannel, sprayTypeNumChannels = fieldGroundSystem:getDensityMapData(FieldDensityMap.SPRAY_TYPE)
		local sprayType = fieldGroundSystem:getFieldSprayValue(FieldSprayType.FERTILIZER)
		local sprayTypeMaxValue = fieldGroundSystem:getMaxValue(FieldDensityMap.SPRAY_TYPE)
		local sprayLevelMaxValue = fieldGroundSystem:getMaxValue(FieldDensityMap.SPRAY_LEVEL)
		
		-- rebuild as loop for all from category GRASSROLLER
		functionData = {}
		functionData.InnerList = {}
		local fruitTypes = g_fruitTypeManager:getFruitTypesByCategoryNames("GRASSROLLER", "Warning: updateGrassRollerArea has invalid fruitTypeCategory '%s'")
		-- TerraLiveExtension.DebugTable("fruitTypes", fruitTypes)
		for _, fruitType in pairs(fruitTypes) do
			local grassDesc = g_fruitTypeManager:getFruitTypeByIndex(fruitType)
			
			functionData.InnerList[fruitType] = {}
			
			functionData.InnerList[fruitType].grassModifier = DensityMapModifier.new(grassDesc.terrainDataPlaneId, grassDesc.startStateChannel, grassDesc.numStateChannels, terrainRootNode)
			
			functionData.InnerList[fruitType].grassFilter = DensityMapFilter.new(grassDesc.terrainDataPlaneId, grassDesc.startStateChannel, grassDesc.numStateChannels, terrainRootNode)
			-- Change Note: grassDesc.cutState was initially 30, with mulcher.state being 31. This means cutState - 1 would have been the same as witheredState
			--              CutState and mulcher.state were flipped, however. This code now uses witheredState so the order of cutState and mulcher.state doesn't matter
			functionData.InnerList[fruitType].grassFilter:setValueCompareParams(DensityValueCompareType.BETWEEN, 10, grassDesc.witheredState)
			
			functionData.InnerList[fruitType].noGrassVisibleFilter = DensityMapFilter.new(grassDesc.terrainDataPlaneId, grassDesc.startStateChannel, grassDesc.numStateChannels, terrainRootNode)
			functionData.InnerList[fruitType].noGrassVisibleFilter:setValueCompareParams(DensityValueCompareType.EQUAL, 0)
		end

		functionData.sprayTypeModifier = DensityMapModifier.new(sprayTypeMapId, sprayTypeFirstChannel, sprayTypeNumChannels, terrainRootNode)
		
		functionData.sprayLevelModifier = DensityMapModifier.new(sprayLevelMapId, sprayLevelFirstChannel, sprayLevelNumChannels, terrainRootNode)
		
		functionData.outsideFieldFilter = DensityMapFilter.new(groundTypeMapId, groundTypeFirstChannel, groundTypeNumChannels)
		functionData.outsideFieldFilter:setValueCompareParams(DensityValueCompareType.EQUAL, 0)

		functionData.sprayTypeFilter = DensityMapFilter.new(sprayTypeMapId, sprayTypeFirstChannel, sprayTypeNumChannels)
		functionData.sprayTypeFilter:setValueCompareParams(DensityValueCompareType.GREATER, sprayType)

		if sprayType > 0 then
			functionData.sprayTypeFilter2 = DensityMapFilter.new(sprayTypeMapId, sprayTypeFirstChannel, sprayTypeNumChannels)
			functionData.sprayTypeFilter2:setValueCompareParams(DensityValueCompareType.BETWEEN, 0, sprayType - 1)
		end

		functionData.notMaxSprayLevelFilter = DensityMapFilter.new(sprayLevelMapId, sprayLevelFirstChannel, sprayLevelNumChannels)
		functionData.notMaxSprayLevelFilter:setValueCompareParams(DensityValueCompareType.BETWEEN, 0, sprayLevelMaxValue - 1)

		functionData.areaMaskedFilter = DensityMapFilter.new(sprayTypeMapId, sprayTypeFirstChannel, sprayTypeNumChannels)
		functionData.areaMaskedFilter:setValueCompareParams(DensityValueCompareType.EQUAL, sprayTypeMaxValue)

		functionData.sprayType = sprayType
		functionData.maskValue = sprayTypeMaxValue
		local stoneSystem = g_currentMission.stoneSystem

		if stoneSystem:getMapHasStones() then
			local stoneMapId, stoneFirstChannel, stoneNumChannels = stoneSystem:getDensityMapData()
			local stoneMinValue = stoneSystem:getMinMaxValues()

			functionData.stoneModifier = DensityMapModifier.new(stoneMapId, stoneFirstChannel, stoneNumChannels, terrainRootNode)
			functionData.stoneModifier:setPolygonRoundingMode(DensityRoundingMode.NEAREST)

			functionData.stoneFilter = DensityMapFilter.new(stoneMapId, stoneFirstChannel, stoneNumChannels, terrainRootNode)
			functionData.stoneFilter:setValueCompareParams(DensityValueCompareType.EQUAL, stoneMinValue)
		end

		FSDensityMapUtil.functionCache.updateGrassRollerArea = functionData
	end

	local sprayLevelModifier = functionData.sprayLevelModifier
	local sprayTypeModifier = functionData.sprayTypeModifier
	local stoneModifier = functionData.stoneModifier
	local stoneFilter = functionData.stoneFilter
	local outsideFieldFilter = functionData.outsideFieldFilter
	local sprayTypeFilter = functionData.sprayTypeFilter
	local sprayTypeFilter2 = functionData.sprayTypeFilter2
	local notMaxSprayLevelFilter = functionData.notMaxSprayLevelFilter
	local areaMaskedFilter = functionData.areaMaskedFilter
	local sprayType = functionData.sprayType
	local maskValue = functionData.maskValue
	
	sprayLevelModifier:setParallelogramWorldCoords(startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, DensityCoordType.POINT_POINT_POINT)
	sprayTypeModifier:setParallelogramWorldCoords(startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, DensityCoordType.POINT_POINT_POINT)

	if removeStones ~= false and stoneModifier ~= nil then
		stoneModifier:setParallelogramWorldCoords(startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, DensityCoordType.POINT_POINT_POINT)
	end

	for fruitType, innerFunctionData in pairs(functionData.InnerList) do
		innerFunctionData.grassModifier:setParallelogramWorldCoords(startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, DensityCoordType.POINT_POINT_POINT)
		sprayTypeModifier:executeSet(maskValue, innerFunctionData.grassFilter, sprayTypeFilter, notMaxSprayLevelFilter)
		if sprayTypeFilter2 ~= nil then
			sprayTypeModifier:executeSet(maskValue, innerFunctionData.grassFilter, sprayTypeFilter2, notMaxSprayLevelFilter)
		end
	end
	
	sprayTypeModifier:executeSet(0, areaMaskedFilter, outsideFieldFilter)

	local _, _, numPixels, totalNumPixels = sprayLevelModifier:executeAdd(1, areaMaskedFilter)

	sprayTypeModifier:executeSet(sprayType, areaMaskedFilter)
	
	for fruitType, innerFunctionData in pairs(functionData.InnerList) do
		innerFunctionData.grassModifier:executeSet(11, innerFunctionData.grassFilter)
	end

	if removeStones ~= false and stoneModifier ~= nil then
		stoneModifier:executeAdd(-1, stoneFilter)
	end

	return numPixels, totalNumPixels
end



FSDensityMapUtil.updateWheelDestructionArea = Utils.overwrittenFunction(FSDensityMapUtil.updateWheelDestructionArea, FSDensityMapUtilExtension.updateWheelDestructionArea)
FSDensityMapUtil.updateWeederArea = Utils.overwrittenFunction(FSDensityMapUtil.updateWeederArea, FSDensityMapUtilExtension.updateWeederArea)
FSDensityMapUtil.updateGrassRollerArea = Utils.overwrittenFunction(FSDensityMapUtil.updateGrassRollerArea, FSDensityMapUtilExtension.updateGrassRollerArea)

FruitTypeManagerExtension = {}
function FruitTypeManagerExtension:loadFruitTypeDestruction(superFunc, fruitType, xmlFile, key)
	-- print(string.format("FruitTypeManagerExtension.loadFruitTypeDestruction(%s, %s, %s, %s)", superFunc, fruitType, xmlFile, key))
	if fruitType ~= nil then
		fruitType.destruction = fruitType.destruction or {}

		if hasXMLProperty(xmlFile, key .. ".destruction") then
			local destruction = fruitType.destruction
			destruction.onlyOnField = Utils.getNoNil(getXMLBool(xmlFile, key .. ".destruction#onlyOnField"), Utils.getNoNil(destruction.onlyOnField, true))
			destruction.filterStart = getXMLInt(xmlFile, key .. ".destruction#filterStart", destruction.filterStart)
			destruction.filterEnd = getXMLInt(xmlFile, key .. ".destruction#filterEnd", destruction.filterEnd)
			destruction.state = getXMLInt(xmlFile, key .. ".destruction#state") or destruction.state or fruitType.cutState
			destruction.canBeDestroyed = Utils.getNoNil(getXMLBool(xmlFile, key .. ".destruction#canBeDestroyed"), Utils.getNoNil(destruction.canBeDestroyed, true))
		end
		
		fruitType.destructionPlus = fruitType.destructionPlus or {}
		if hasXMLProperty(xmlFile, key .. ".destructionPlus") then
			local destructionPlus = fruitType.destructionPlus
			destructionPlus.onlyOnField = Utils.getNoNil(getXMLBool(xmlFile, key .. ".destructionPlus#onlyOnField"), Utils.getNoNil(destructionPlus.onlyOnField, true))
			destructionPlus.filterStart = getXMLInt(xmlFile, key .. ".destructionPlus#filterStart", destructionPlus.filterStart)
			destructionPlus.filterEnd = getXMLInt(xmlFile, key .. ".destructionPlus#filterEnd", destructionPlus.filterEnd)
			destructionPlus.state = getXMLInt(xmlFile, key .. ".destructionPlus#state") or destructionPlus.state or fruitType.cutState
			destructionPlus.canBeDestroyed = Utils.getNoNil(getXMLBool(xmlFile, key .. ".destructionPlus#canBeDestroyed"), Utils.getNoNil(destructionPlus.canBeDestroyed, true))
		end

		fruitType.mulcher = fruitType.mulcher or {}
		fruitType.mulcher.state = Utils.getNoNil(getXMLInt(xmlFile, key .. ".mulcher#state"), fruitType.mulcher.state or 2^fruitType.numStateChannels - 1)
		fruitType.mulcher.hasChopperGroundLayer = Utils.getNoNil(getXMLBool(xmlFile, key .. ".mulcher#hasChopperGroundLayer"), Utils.getNoNil(fruitType.mulcher.hasChopperGroundLayer, true))
		local chopperTypeName = getXMLString(xmlFile, key .. ".harvest#chopperTypeName") or "CHOPPER_STRAW"

		if chopperTypeName ~= nil then
			fruitType.mulcher.chopperTypeIndex = g_currentMission.fieldGroundSystem:getChopperTypeIndexByName(chopperTypeName)
		end

		local defaultColorString = getXMLString(xmlFile, key .. ".mapColors#default") or "1 1 1 1"
		local defaultColorBlindString = getXMLString(xmlFile, key .. ".mapColors#colorBlind") or "1 1 1 1"
		fruitType.defaultMapColor = GuiUtils.getColorArray(defaultColorString) or fruitType.defaultMapColor
		fruitType.colorBlindMapColor = GuiUtils.getColorArray(defaultColorBlindString) or fruitType.colorBlindMapColor

		return true
	end

	return false
end

FruitTypeManager.loadFruitTypeDestruction = Utils.overwrittenFunction(FruitTypeManager.loadFruitTypeDestruction, FruitTypeManagerExtension.loadFruitTypeDestruction)


WeederExtension = {}
function WeederExtension:processWeederArea(superFunc, workArea, dt)
	local spec = self.spec_weeder
	local xs, _, zs = getWorldTranslation(workArea.start)
	local xw, _, zw = getWorldTranslation(workArea.width)
	local xh, _, zh = getWorldTranslation(workArea.height)
	local area = FSDensityMapUtil.updateWeederArea(xs, zs, xw, zw, xh, zh, spec.isHoeWeeder)

	-- overridden currently only because of in TL a weeder could not be a grass roller anymore
	-- if spec.isGrasslandWeeder then
		-- local _area = FSDensityMapUtil.updateGrassRollerArea(xs, zs, xw, zw, xh, zh, false)
		-- area = math.max(area, _area)
	-- end

	spec.workAreaParameters.lastArea = spec.workAreaParameters.lastArea + area
	spec.workAreaParameters.lastStatsArea = spec.workAreaParameters.lastStatsArea + area
	spec.isWorking = self:getLastSpeed() > 0.5

	if spec.isWorking then
		spec.stoneLastState = FSDensityMapUtil.getStoneArea(xs, zs, xw, zw, xh, zh)
	else
		spec.stoneLastState = 0
	end

	return area, area
end

Weeder.processWeederArea = Utils.overwrittenFunction(Weeder.processWeederArea, WeederExtension.processWeederArea)
















--[[ Currently dead code

-- von Sam, keine ahnung ob das noch gebraucht wird, deshalb lasse ich es stehen
function updateLimeArea(startWorldX,SuperFunc, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, groundType)
	
	local numPixels, totalNumPixels = SuperFunc(startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, groundType)
	local modifiers = FSDensityMapUtil.functionCache.updateLimeArea
	local modifier = modifiers.modifier
	local filter1 = modifiers.filter1
	local filter2 = modifiers.filter2
	local detailId = g_currentMission.terrainDetailId
	local limeCounterFirstChannel = g_currentMission.limeCounterFirstChannel
	local limeCounterNumChannels = g_currentMission.limeCounterNumChannels
	local limeCounterMaxValue = g_currentMission.limeCounterMaxValue
	for index, entry in pairs(g_fruitTypeManager:getFruitTypes()) do
		local desc = g_fruitTypeManager:getFruitTypeByIndex(index)

		if desc.weed == nil then

			filter1:resetDensityMapAndChannels(entry.id, desc.startStateChannel, desc.numStateChannels)
			filter1:setValueCompareParams("equal", desc.cutState + 2) -- Note: cutState is usually 31 or 30, so this filter would never match anything
			modifier:resetDensityMapAndChannels(detailId, g_currentMission.sprayFirstChannel, g_currentMission.sprayNumChannels)
			
			local _, _, _ = modifier:executeSet(groundType, filter1)
			
			modifier:resetDensityMapAndChannels(detailId, limeCounterFirstChannel, limeCounterNumChannels)
			
			local _, numP, _ = modifier:executeSet(limeCounterMaxValue, filter1, filter2)
			numPixels = numPixels + numP
		end
	end

	return numPixels, totalNumPixels
end
]]

-- FSBaseMission.loadMapFinished = Utils.appendedFunction(FSBaseMission.loadMapFinished, FruitDestructionReloadedFSBaseMissionExtension.onLoadMapFinished)
-- FSDensityMapUtil.updateLimeArea = Utils.overwrittenFunction(FSDensityMapUtil.updateLimeArea, updateLimeArea)
