mapFilterExtension = {}

function mapFilterExtension:loadFilters()
	local fruitValue = g_gameSettings:getValue(GameSettings.SETTING.INGAME_MAP_FRUIT_FILTER)

	--Grass einblenden
	self.fruitTypeFilter[FruitType.GRASS] = true

	--Deko ausblenden
	self.fruitTypeFilter[FruitType.ROADSIDEGRASS] = false
	self.fruitTypeFilter[FruitType.LAWNGRASS] = false

	for _, fruitName in ipairs(fruitValue:split(";")) do
		local fruitDesc = g_fruitTypeManager:getFruitTypeByName(fruitName)

		if fruitDesc ~= nil then
			self.fruitTypeFilter[fruitDesc.index] = false
		end
	end

	local growthValue = g_gameSettings:getValue(GameSettings.SETTING.INGAME_MAP_GROWTH_FILTER)

	for i = 1, #self.displayGrowthStates do
		self.growthStateFilter[i] = Utils.isBitSet(growthValue, i)
	end

	local soilValue = g_gameSettings:getValue(GameSettings.SETTING.INGAME_MAP_SOIL_FILTER)

	for i = 1, #self.displaySoilStates do
		self.soilStateFilter[i] = Utils.isBitSet(soilValue, i)
	end
end

InGameMenuMapFrame.loadFilters = Utils.overwrittenFunction(InGameMenuMapFrame.loadFilters, mapFilterExtension.loadFilters)