realismAddon_animalGrazing_register = {};

local modName = g_currentModName;
local modDirectory = g_currentModDirectory;

realismAddon_animalGrazing_register.modDirectory = modDirectory

-- add specializations to vehicleTypes 
function realismAddon_animalGrazing_register:register(name)

	-- make sure this only runs once since typeManager runce twice (vehicle and placeables)
    if realismAddon_animalGrazing_register.installed == nil then
	
		-- add/register specializations 
		g_placeableSpecializationManager:addSpecialization("realismAddon_animalGrazing", "realismAddon_animalGrazing", modDirectory.."scripts/realismAddon_animalGrazing.lua", nil)

		-- cycle vehicleTypes, add specs 
		for _, placeable in pairs(g_placeableTypeManager:getTypes()) do
		
			local placeableHusbandry = false
			local realismAddon_animalGrazing = false
			for _, spec in pairs(placeable.specializationNames) do
				if spec == "FS22_TerraLifePlus.realismAddon_animalGrazing" then 
					realismAddon_animalGrazing = true;
				end
				if spec == "husbandry" then
					placeableHusbandry = true;
				end;
			end    
			if not realismAddon_animalGrazing and placeableHusbandry then
				g_placeableTypeManager:addSpecialization(placeable.name, "FS22_TerraLifePlus.realismAddon_animalGrazing")
			end

			realismAddon_animalGrazing_register.installed = true
		end
	end
end
TypeManager.finalizeTypes = Utils.prependedFunction(TypeManager.finalizeTypes, realismAddon_animalGrazing_register.register)

addModEventListener(realismAddon_animalGrazing_register)