-- Registering T+ specialiations 
-- by modelleicher (Farming Agency)


registerTerraLifeSpecs = {};

local modName = g_currentModName;
local modDirectory = g_currentModDirectory;
registerTerraLifeSpecs.modDirectory = modDirectory;
registerTerraLifeSpecs.modName = g_currentModName;
registerTerraLifeSpecs.addingDone = false

function registerTerraLifeSpecs.emptyFunctionDoNothing()

end

function registerTerraLifeSpecs:register(name)
	
	if not registerTerraLifeSpecs.addingDone then -- only run once since register added to finalizeTypes is called twice (vehicle & placeable)

		g_specializationManager:addSpecialization("mixerWagonRecipeChanger", "mixerWagonRecipeChanger", modDirectory.."scripts/mixerWagonRecipeChanger.lua", nil)

		for _, vehicle in pairs(g_vehicleTypeManager:getTypes()) do
			
			local mixerWagonRecipeChanger = false;
			local mixerWagon = false;
			
			for _, spec in pairs(vehicle.specializationNames) do
				if spec == modName..".mixerWagonRecipeChanger" then 
					mixerWagonRecipeChanger = true;
				end
				if spec == "mixerWagon" then
					mixerWagon = true;
				end;			
			end    
			if not mixerWagonRecipeChanger and mixerWagon then
				g_vehicleTypeManager:addSpecialization(vehicle.name, modName..".mixerWagonRecipeChanger")
			end
		
		end
		registerTerraLifeSpecs.addingDone = true
	end
	
end
TypeManager.finalizeTypes = Utils.prependedFunction(TypeManager.finalizeTypes, registerTerraLifeSpecs.register)


addModEventListener(registerTerraLifeSpecs)