--[[
RemoveItems.lua
Removes Vanilla Items from Shop with a message. Just add the filenames(with path) to this file and load it ingame with the modDesc.

Free to use.
	
Author: 	Braeven
Date:		09.07.2024
Version:	1.2.0.0

History:	v1.0.0.0 @05.05.2022 - Initial Release
					V1.1.0.0 @10.01.2023 - Fixed a Bug with already removed Items and added the modname to the removed-message.
					V1.2.0.0 @09.07.2024 - Edited Version for TerraLifePlis
]]

RemoveStuff = {};

function RemoveStuff.loadMap(filename)
  StufftoRemove = {"data/placeables/lizard/productionPoints/bakeryEU/bakeryEU.xml",
										"data/placeables/lizard/productionPoints/bakeryUS/bakeryUS.xml",
										"data/placeables/lizard/productionPoints/carpenterEU/carpenterEU.xml",
										"data/placeables/lizard/productionPoints/carpenterUS/carpenterUS.xml",
										"data/placeables/lizard/productionPoints/cerealFactory/cerealFactory.xml",
										"data/placeables/lizard/productionPoints/dairyEU/dairyEU.xml",
										"data/placeables/lizard/productionPoints/dairyUS/dairyUS.xml",
										"data/placeables/lizard/productionPoints/grainMill/grainMill.xml",
										"data/placeables/lizard/productionPoints/oilPlant/oilPlant.xml",
										"data/placeables/lizard/productionPoints/raisinFactory/raisinFactory.xml",
										"data/placeables/lizard/productionPoints/spinneryEU/spinneryEU.xml",
										"data/placeables/lizard/productionPoints/spinneryUS/spinneryUS.xml",
										"data/placeables/lizard/productionPoints/sugarMill/sugarMill.xml",
										"data/placeables/lizard/productionPoints/tailorShop/tailorShop.xml",
										"data/placeables/lizard/greenhouses/greenhouseSmall/greenhouseSmall.xml",
										"data/placeables/lizard/greenhouses/greenhouseMedium/greenhouseMedium.xml",
										"data/placeables/lizard/greenhouses/greenhouseLarge/greenhouseLarge.xml",
										"data/placeables/planET/bga99kw/bga99kw.xml",
										"data/placeables/planET/bga250kw/bga250kw.xml",
										"data/placeables/planET/bga500kw/bga500kw.xml",
										"data/placeables/planET/bga1mw/bga1mw.xml",
										"data/placeables/lizard/sellingPoints/farmersMarket/farmersMarket.xml",
										"data/placeables/lizard/sellingPoints/pizzeria/pizzeria.xml",
										"data/placeables/lizard/sellingPoints/restaurant/restaurant.xml",
										"data/placeables/lizard/sellingPoints/supermarket/supermarket.xml",
										"data/placeables/lizard/sellingPoints/bhp/bhp.xml",
										"data/placeables/lizard/sellingPoints/fastFoodRestaurant/fastFoodRestaurant.xml"}
	for _, xmlFilename in pairs(StufftoRemove) do
    local removed = g_storeManager:getItemByXMLFilename(xmlFilename)
    if removed == nil then
      --print("Can't remove: '" .. tostring(xmlFilename) .. "' from Shop, does not exist or was removed before.")
    else
      g_storeManager:removeItemByIndex(removed.id)
		  --print("Removed: '" .. tostring(xmlFilename) .. "' from Shop.")
    end
  end
end

addModEventListener(RemoveStuff);