FillableImplementExtension = {}
FillableImplementExtension.debug = false;

function FillableImplementExtension.prerequisitesPresent(specializations)
	return true;
end

function FillableImplementExtension.registerEventListeners(vehicleType)
	SpecializationUtil.registerEventListener(vehicleType, "onLoad", FillableImplementExtension)
end

function FillableImplementExtension:onLoad(savegame)
	local spec = self.spec_fillUnit;
	
	-- bei seeds alle speziellen saatgüter bei schreiben nur nutzung
	local fillUnitIndex = self:getFirstValidFillUnitToFill(FillType.SEEDS, true)
	if fillUnitIndex ~= nil then
		for _, fruitType in ipairs(g_fruitTypeManager:getFruitTypes()) do
			
			local seedFillTypeName = "SEEDS_" .. fruitType.name;
			local seedFillTypeIndex = g_fillTypeManager:getFillTypeIndexByName(seedFillTypeName);
			if seedFillTypeIndex ~= nil then
				spec.fillUnits[fillUnitIndex].supportedFillTypes[seedFillTypeIndex] = true;
			elseif FillableImplementExtension.debug then
				Logging.warning("TerraLifeError: Missing special seed Type '%s'", seedFillTypeName)
			end
		end
	end
end

FillUnitExtension = {}
function FillUnitExtension:getFirstValidFillUnitToFill(superFunc, fillType, ignoreCapacity)
	local spec = self.spec_fillUnit

	for fillUnitIndex, _ in ipairs(spec.fillUnits) do
		-- TerraLiveExtension.DebugText("FillUnitExtension:getFillUnitAllowsFillType: %s", self:getFillUnitAllowsFillType(fillUnitIndex, fillType))
		-- TerraLiveExtension.DebugText("FillUnitExtension:getFillUnitSupportsFillType: %s", self:getFillUnitSupportsFillType(fillUnitIndex, fillType))
		-- TerraLiveExtension.DebugText("FillUnitExtension:getFillUnitFreeCapacity: %s", self:getFillUnitFreeCapacity(fillUnitIndex))
		if self:getFillUnitSupportsFillType(fillUnitIndex, fillType) and (self:getFillUnitFreeCapacity(fillUnitIndex) > 0 or ignoreCapacity ~= nil and ignoreCapacity) then
			-- TerraLiveExtension.DebugText("FillUnitExtension:getFirstValidFillUnitToFill(%s, %s) - %s", fillType, ignoreCapacity, fillUnitIndex)
			return fillUnitIndex
		end
	end
	-- TerraLiveExtension.DebugText("FillUnitExtension:getFirstValidFillUnitToFill(%s, %s) - nil", fillType, ignoreCapacity)
	return nil
end

FillUnit.getFirstValidFillUnitToFill = Utils.overwrittenFunction(FillUnit.getFirstValidFillUnitToFill, FillUnitExtension.getFirstValidFillUnitToFill)