ManuelDischargerCreateObjectEvent = {}

local ManuelDischargerCreateObjectEvent_mt = Class(ManuelDischargerCreateObjectEvent, Event)
InitEventClass(ManuelDischargerCreateObjectEvent, "ManuelDischargerCreateObjectEvent")

function ManuelDischargerCreateObjectEvent.emptyNew()
    local self = Event.new(ManuelDischargerCreateObjectEvent_mt)

    return self
end

function ManuelDischargerCreateObjectEvent.new(pallet)
    local self = ManuelDischargerCreateObjectEvent.emptyNew()

    self.pallet = pallet

    return self
end

function ManuelDischargerCreateObjectEvent:readStream(streamId, connection)
    self.pallet = NetworkUtil.readNodeObject(streamId)

    self:run(connection)
end

function ManuelDischargerCreateObjectEvent:writeStream(streamId, connection)
    NetworkUtil.writeNodeObject(streamId, self.pallet)
end

function ManuelDischargerCreateObjectEvent:run(connection)
    if not connection:getIsServer() then
        local player = g_currentMission:getPlayerByConnection(connection)
        if player ~= nil then
            ManuelDischarger.spawnObject(self.pallet, player)
        else
            Logging.warning("Player not found")
        end
    end
end
