ManuelDischargerShowWarningEvent = {}

local ManuelDischargerShowWarningEvent_mt = Class(ManuelDischargerShowWarningEvent, Event)
InitEventClass(ManuelDischargerShowWarningEvent, "ManuelDischargerShowWarningEvent")

function ManuelDischargerShowWarningEvent.emptyNew()
    local self = Event.new(ManuelDischargerShowWarningEvent_mt)

    return self
end

function ManuelDischargerShowWarningEvent.new(player, text)
    local self = ManuelDischargerShowWarningEvent.emptyNew()
    self.player = player
    self.text = text
    return self
end

function ManuelDischargerShowWarningEvent:readStream(streamId, connection)
    self.player = NetworkUtil.readNodeObject(streamId)
    self.text = streamReadString(streamId)
    self:run(connection)
end

function ManuelDischargerShowWarningEvent:writeStream(streamId, connection)
    NetworkUtil.writeNodeObject(streamId, self.player)
    streamWriteString(streamId, self.text)
end

function ManuelDischargerShowWarningEvent:run(connection)
    if self.player == g_currentMission.player then
        g_currentMission:showBlinkingWarning(self.text, 3000)
    end
end
