ManuelDischargerStoreObjectEvent = {}

local ManuelDischargerStoreObjectEvent_mt = Class(ManuelDischargerStoreObjectEvent, Event)
InitEventClass(ManuelDischargerStoreObjectEvent, "ManuelDischargerStoreObjectEvent")

function ManuelDischargerStoreObjectEvent.emptyNew()
    local self = Event.new(ManuelDischargerStoreObjectEvent_mt)

    return self
end

function ManuelDischargerStoreObjectEvent.new(palletsInRange)
    local self = ManuelDischargerStoreObjectEvent.emptyNew()
    self.palletsInRange = palletsInRange
    return self
end

function ManuelDischargerStoreObjectEvent:readStream(streamId, connection)
    self.palletsInRange = {}
    local numPallets = streamReadInt8(streamId)

    for i = 1, numPallets do
        local pallet = NetworkUtil.readNodeObject(streamId)
        table.insert(self.palletsInRange, pallet)
    end

    self:run(connection)
end

function ManuelDischargerStoreObjectEvent:writeStream(streamId, connection)
    streamWriteInt8(streamId, #self.palletsInRange)
    for _, pallet in pairs(self.palletsInRange) do
        NetworkUtil.writeNodeObject(streamId, pallet)
    end
end

function ManuelDischargerStoreObjectEvent:run(connection)
    if not connection:getIsServer() then
        local player = g_currentMission:getPlayerByConnection(connection)
        if player ~= nil then
            ManuelDischarger.storeObject(player, self.palletsInRange)
        else
            Logging.warning("Player not found")
        end
    end
end
