-- add additional fillTypes to straw blowers so all major bales can be dissolved 
-- by modelleicher (Farming Agency)

strawBlowerExtension = {}


function strawBlowerExtension.onLoad(self, superFunc, ...)
	local returnValue = superFunc(self, ...)
	
	local fillUnit = self:getFillUnitByIndex(self.spec_strawBlower.fillUnitIndex)
	
	-- list of current TLP bale fillTypes 
	local names = {"grass_fermented", "fieldGrass_fermented", "cloverGrass_fermented", "pastureGrass_fermented", "horseGrass_fermented", "herbGrass_fermented", "alfalfa_fermented", "clover_fermented", "silage", "maizestraw_fermented", "choppedmaize_fermented", "dryGrass_windrow", "dryFieldGrass_windrow", "dryCloverGrass_windrow", "dryPastureGrass_windrow", "dryHorseGrass_windrow", "dryHerbGrass_windrow", "dryAlfalfa_windrow", "dryClover_windrow", "barleystraw", "oatstraw", "speltstraw", "ryestraw", "triticalestraw", "maizestraw", "compostraw"}

	for _, name in pairs(names) do
		if g_fillTypeManager:getFillTypeIndexByName(name) ~= nil then
			fillUnit.supportedFillTypes[g_fillTypeManager:getFillTypeIndexByName(name)] = true
		end;
	end;
	
	return returnValue
end;
StrawBlower.onLoad = Utils.overwrittenFunction(StrawBlower.onLoad, strawBlowerExtension.onLoad)
	