--waterTrailerExtension
--Adds new Fluids into Basegame Water-Tankers

waterTrailerExtension = {}

function waterTrailerExtension.loadFillUnitFromXML(self, superFunc, xmlFile, key, entry, index)
	local test = string.upper(xmlFile:getValue("vehicle#type", ""))
	if test == "WATERTRAILER" then
		local fillTypeNames = xmlFile:getValue(key .. "#fillTypes")
		if fillTypeNames ~= nil then
			local gotMilk = false
			local fillTypes = string.split(fillTypeNames, " ")
			
			for i = 1, #fillTypes do
				local fillType = fillTypes[i]
				if fillType:upper() == "MILK" then
					gotMilk = true
				end
			end
			if gotMilk then
				fillTypeNames = fillTypeNames .. " HAYMILK GOATMILK SHEEPMILK LIQUIDCARBOLIME"
				xmlFile:setValue(key .. "#fillTypes", fillTypeNames)
			end
		end
	end

	local returnValue = superFunc(self, xmlFile, key, entry, index)

	return returnValue
end

FillUnit.loadFillUnitFromXML = Utils.overwrittenFunction(FillUnit.loadFillUnitFromXML, waterTrailerExtension.loadFillUnitFromXML)


function waterTrailerExtension.loadSpecValueFillTypes(xmlFile, superFunc, customEnvironment, baseDir)
	local rootName = xmlFile:getRootName()
	local test = string.upper(xmlFile:getValue("vehicle#type", ""))
	if test:upper() == "WATERTRAILER" then
		local i = 0

		while true do
			local key = string.format(rootName .. ".fillUnit.fillUnitConfigurations.fillUnitConfiguration(%d)", i)
			if not xmlFile:hasProperty(key) then
				break
			end

			local j = 0

			while true do
				local unitKey = string.format(key .. ".fillUnits.fillUnit(%d)", j)
				if not xmlFile:hasProperty(unitKey) then
					break
				end

				local showInShop = xmlFile:getValue(unitKey .. "#showInShop")
				local capacity = xmlFile:getValue(unitKey .. "#capacity")

				if (showInShop == nil or showInShop) and (capacity == nil or capacity > 0) then
					local fillTypeNames = xmlFile:getValue(unitKey .. "#fillTypes")
					if fillTypeNames ~= nil then
						local gotMilk = false
						local fillTypes = string.split(fillTypeNames, " ")
						
						for i = 1, #fillTypes do
							local fillType = fillTypes[i]
							if fillType:upper() == "MILK" then
								gotMilk = true
							end
						end
						if gotMilk then
							fillTypeNames = fillTypeNames .. " HAYMILK GOATMILK SHEEPMILK LIQUIDCARBOLIME"
							xmlFile:setValue(unitKey .. "#fillTypes", fillTypeNames)
						end
					end
				end

				j = j + 1
			end

			i = i + 1
		end
	end

	return superFunc(xmlFile, customEnvironment, baseDir)
end

FillUnit.loadSpecValueFillTypes = Utils.overwrittenFunction(FillUnit.loadSpecValueFillTypes, waterTrailerExtension.loadSpecValueFillTypes)